﻿using System;
using System.Collections.Generic;
using System.Text;
using FTGate.Framework;

public class CoreExtension : CoreBehaviour
{
    public int theInt;
    public string theString;

    /// <summary> 
    /// Called when the assembly is loaded/rebuilt
    /// </summary> 
    public void OnInit()
    {
        Log log = new Log();
        log.Write(LogType.Normal, "Hello from Script Assembly OnInit()");
    }

    /// <summary> 
    /// Called just before FTGate main loop starts
    /// </summary> 
    public void OnMainLoopStart()
    {
        Log log = new Log();
        log.Write(LogType.Normal, "Starting main loop");
    }

    /// <summary> 
    /// Called approx every 250ms
    /// </summary> 
    public void OnMainLoop()
    {
        Log log = new Log();
        log.Write(LogType.Debug, "250ms timer");
    }

    /// <summary> 
    /// Called after main loop stops and shutdown starts
    /// </summary> 
    public void OnMainLoopEnd()
    {
        Log log = new Log();
        log.Write(LogType.Normal, "Ending main loop");
    }
}
