﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using FTGate.Framework;

public class SpoolerExtension : SpoolBehaviour
{
    /// <summary>
    /// Called by a the spooler when it starts processing a new message
    /// </summary> 
    public ProcessMessageReturnType OnPreProcessMessage(MailMessage message)
    {
        ProcessMessageReturnType retVal = ProcessMessageReturnType.Continue;
        Log log = new Log();
        // to get the envelope
        string from = "";
        List<string> to = new List<string>();
        string envelope = message.envelopePath;

        string m = "";
        StreamReader r = new StreamReader(envelope);
        if (!r.EndOfStream)
            from = r.ReadLine();
        while (r.EndOfStream == false)
        {
            m = r.ReadLine();
            if (m != "")
                to.Add(m);
        }
        r.Close();        
        // process
        try
        {
            // do whatever you want in here
            foreach (string recipient in to)
                log.Write(LogType.Debug, "Spooler PreProcessMessage called from "+from+" to "+recipient);
            // if you want to delete or have deleted the message set this
            retVal = ProcessMessageReturnType.RequestDelete;
        }
        catch (Exception e)
        {
            retVal = ProcessMessageReturnType.Error; // error case
        }
        return retVal;
    }
}

