﻿//
//
// Function for controlling the login page
//
//

if (!window.localStorage)
    window.location.href = '/notsupported.htm'

// disableMobile
// false to force mobile to the mobile subfolders
// true to allow access to the normal webmail interface
var disableMobileRedirect=true

function isMobile() {
    ///<summary>Detecting whether the browser is a mobile browser or desktop browser</summary>
    ///<returns>A boolean value indicating whether the browser is a mobile browser or not</returns>

    if (sessionStorage.desktop) // desktop storage 
        return false;
    else if (localStorage.mobile) // mobile storage
        return true;

    // alternative
    if (!disableMobileRedirect) {
        var mobile = ['iphone', 'ipad', 'android', 'blackberry', 'nokia', 'opera mini', 'windows mobile', 'windows phone', 'iemobile'];
        for (var i in mobile) if (navigator.userAgent.toLowerCase().indexOf(mobile[i].toLowerCase()) > 0) return true;
    }
    // nothing found.. assume desktop
    return false;
}

if (isMobile())
    top.location.href="/v7/mobile/"

// jumpt to top page if in a frame
if (top.location.href != window.location.href) {
    top.location.href = window.location.href
}



var dataStore = {}
dataStore.clear = function () {
    dataStore = {}
    dataStore.removeItem = function (v) { dataStore[v] = undefined }
}

if (localStorage)
    dataStore = localStorage
else
    dataStore.clear()

var dlgWin
var dhxWins
var isIE = false;

function closeIt() {
    dlgWin.close();
}

function init()
{
	if (expire!="")
	{
		var dt=icalDate(expire)
		var txt='<br><big><span style="color:red;font-weight:bold">'
		txt+='This build expires '+dt.toLocaleString();
		txt+='</span></big><br/>&nbsp;'
        document.getElementById('expiryblock').innerHTML=txt
	}

	if (wantSetup)
	{
		dhxWins= new dhtmlXWindows();
		dlgWin = dhxWins.createWindow("w1", 0, 40, "665", "450");
		dlgWin.setText("FTGate7 Setup")
		//evid=dlgWin.attachEvent("onClose", CloseDialog)
		dlgWin.attachURL("/setup.fts")
		dlgWin.setModal(true)
		dlgWin.center();
		document.getElementById("welcomePane").style.display = "none";
	}
	else
	{
	    if (signout != '') {
	        dataStore.removeItem("username");
	        dataStore.removeItem("nonce")
	        dataStore.removeItem("remember")
	        dataStore.removeItem("autologin")
	    }
	    else {
	        if (blockauto == 0) {
	            if (dataStore["remember"] == "true") {
	                if (dataStore["username"])
	                    document.getElementById("mailbox").value = dataStore["username"]
	                if (dataStore["remember"])
	                    document.getElementById("rememberme").checked = dataStore["remember"] == "true"
	                if (dataStore["autologin"])
	                    document.getElementById("autologin").checked = dataStore["autologin"] == "true"
	            }
	            if (dataStore["autologin"] == "true" || redirected != "")
	                autologin()
	        }
	    }
	}
	if (typeof (window.navigator.appVersion) != undefined) {
	    isIE11 = window.navigator.appVersion.indexOf("Trident/7.0") != -1
	    isIE10 = window.navigator.appVersion.indexOf("Trident/6.0") != -1
	    isIE = isIE11 || isIE10
	}
}




var _ajax = 0
var auto = false;
var b64
var remember = false;

function doLogin() {
    email = document.getElementById("mailbox").value
    email = email.toLowerCase();
    try {
        if (dataStore["username"] != email) {
            // different user so clear any local storage
            dataStore.clear()
        }
    }
    catch (e) {
        alert("FTGate cannot be used in a browsers private browsing mode");
        //return;
    }
    dataStore["username"]= email;
    password = document.getElementById("password").value
    if (blockauto == 0) {
        remember = document.getElementById("rememberme").checked
        auto = document.getElementById("autologin").checked
    }
    b64 = Base64.encode(email + ":" + password)
    dataStore.removeItem("nonce")
    dataStore.removeItem("remember")
    dataStore.removeItem("autologin")
    if (remember)
    {
        dataStore["nonce"]=""
        dataStore["remember"] = "true"
        if (auto)
            dataStore["autologin"] = "true";
    }
    auto=false
    _ajax = new ajaxCore();
    _ajax.init()
    _ajax.getData("/v7/axml/login.fts?id=" + b64+"&auto="+auto+"&remember="+remember+"&isIE="+isIE+"&tzoffset="+new Date().getTimezoneOffset(), loginCallback);
    return false;
}

function autologin() {
    var email
    var password
    var b64

    if (redirected == "") {
        email = dataStore["username"]
        if (email == undefined)
            return;
        password = dataStore["nonce"]
        remember = dataStore["remember"]
        auto = dataStore["autologin"]
        b64 = Base64.encode(email + ":" + password)
    }
    else{
        redirected=redirected.split(':')
        b64 = redirected[1]
        dataStore["username"]=redirected[0]
    }
    auto=true
    _ajax = new ajaxCore();
    _ajax.init()
    _ajax.getData("/v7/axml/login.fts?id=" + b64 + "&auto=" + auto + "&remember=" + remember + "&isIE=" + isIE, loginCallback);
    return false;
}

function loginCallback() {
    var req = _ajax.getChannel()
    if (req.readyState == 4) 
    {
        if (req.status == 200) {
            var t = req.responseText
            t.trim();
            if (t.slice(0, 8) == "REDIRECT") {
                window.location.href = "http://" + t.slice(9, 9999) + "/index.fts?redirect=" + dataStore["username"]+":"+ b64;
            }
            else
                if (t.slice(0, 2) == "ok") {
                    var location = "/home.fts?account=" + t.slice(3);
                    window.location.href = "/home.fts?account="+t.slice(4);
            }
            else {
                document.getElementById("password").value = "";
                document.getElementById("loginerror").style.display = "inline";
            }
        }
        else {
            if (!auto) {
                document.getElementById("password").value = "";
                document.getElementById("loginerror").style.display = "inline";
            }
        }
    }
}
