// called to step to the next event of the sequence
// in dhtml recurrences this is their odd pattern system
// we will use the ical pattern

function debug(log_txt) {
    if (false && typeof window.console != 'undefined') {
        console.log(log_txt);
    }
}


var icalIterator = function () {
    this.rrule = []
    this.theDate = new Date() // current date
    this.startDate = new Date();
    this.count
    this.until
    this.interval = 0
    this._bymonth
    this._byweekno
    this._byyearday
    this._bymonthday
    this._byday
    this._bydayoffset = 0
    this._bydayindex = 0
    this._last = { year: 1970, month: 1, day: 1, hour: 0, minute: 0, second: 0, month_list: [], date_list: [], day_map: [], dow_map: [] }
    this._byrules = false;
    this._oneDay = 86400
    this._recur = false;


    this.init = function (ev) {
        debug(ev.text)
        if (!ev.rrule) {
            delete ev.rec_pattern
            delete ev.rec_type
            if (ev.end_date)
                ev._timed = ev.duration <= 86400 && ev.start_date.getDate() == ev.end_date.getDate()
            else
                ev.timed = true

            return false
        }

        // normalise the date do dispose of any millisecond timers
        this.theDate = ev.start_date;
        this.theDate.setMilliseconds(0)
        this.startDate = ev.start_date;

        ev.rec_pattern = "week_"
        ev.rec_type = "week_"

        var rr = []
        rr = ev.rrule.split(";");

        this.rrule = new Array()
        for (var i = 0; i < rr.length; i++) {
            var sp = rr[i].split("=");
            this.rrule[sp[0]] = sp[1];
        }

        this._setLastDate(this.theDate);

        // expect a count or an until
        this.count = this.rrule["COUNT"] ? parseInt(this.rrule["COUNT"]) : 999999999
        this.until = this.rrule["UNTIL"] ? scheduler.ical.parse_date(this.rrule["UNTIL"]) : new Date(2099, 31, 12)
        this.interval = this.rrule["INTERVAL"] ? parseInt(this.rrule["INTERVAL"]) : 1
        // set the frequency routine to use
        // we ignore seconds, minutes, and hour types as we dont support them
        if (this.rrule["FREQ"] == "DAILY")
            this.next = this._nextDaily
        if (this.rrule["FREQ"] == "WEEKLY")
            this.next = this._nextWeekly
        if (this.rrule["FREQ"] == "MONTHLY")
            this.next = this._nextMonthly
        if (this.rrule["FREQ"] == "YEARLY")
            this.next = this._nextYearly
        // expand the BYxxx fields
        if (this.rrule["BYMONTH"]) {
            this._bymonth = this._expandBy(this.rrule["BYMONTH"])
            for (var k = 0; k < this._bymonth.length; k++)
                this._bymonth[k]--;
        }
        if (this.rrule["BYWEEKNO"])
            this._byweekno = this._expandBy(this.rrule["BYWEEKNO"])
        if (this.rrule["BYYEARDAY"])
            this._byyearday = this._expandBy(this.rrule["BYYEARDAY"])
        if (this.rrule["BYMONTHDAY"]) {
            this._bymonthday = this._expandBy(this.rrule["BYMONTHDAY"])
        }
        if (this.rrule["BYDAY"]) {
            this._byrules = true;
            var t = this.rrule["BYDAY"].slice(0, 1)
            var offsets = "-1234"
            if (offsets.indexOf(t) == -1)
                this._byday = this._expandByDayForWeekly()
            else {
                if (t == "-") {
                    this._bydayoffset = this.rrule["BYDAY"].slice(0, 2)
                    this._bydayindex = this.rrule["BYDAY"].slice(2)
                }
                else {
                    this._bydayoffset = this.rrule["BYDAY"].slice(0, 1)
                    this._bydayindex = this.rrule["BYDAY"].slice(1)
                }
                this._bydayoffset = parseInt(this._bydayoffset)
                if (this._bydayindex == "SU") this._bydayindex = 0
                if (this._bydayindex == "MO") this._bydayindex = 1
                if (this._bydayindex == "TU") this._bydayindex = 2
                if (this._bydayindex == "WE") this._bydayindex = 3
                if (this._bydayindex == "TH") this._bydayindex = 4
                if (this._bydayindex == "FR") this._bydayindex = 5
                if (this._bydayindex == "SA") this._bydayindex = 6
            }
        }
        this._recur = true;
        return true
    }



    this.getDates = function (startDate, endDate) {

        var dates = []

        if (!this._recur)
            return dates;

        startDate.setMilliseconds(0)
        endDate.setMilliseconds(0)

        var ok = true;
        if (this.until && this.until < endDate)
            endDate = this.until;
        if (startDate < this.startDate)
            startDate = this.startDate;


        this._setLastDate(this.theDate);
        if (this._bymonth) {
            this._pushByMonth();
            this._last.month = this._last.month_list.pop()
        }
        if (this._bymonthday) {
            this._pushByMonthDay()
            this._last.day = this._last.date_list.pop()
        }
        this.theDate = this._fromLast();
        if (this._byday) {
            this._last.dow_map = this._byday.slice(0);
            while (this._last.dow_map.length > 0 && this._last.dow_map[this._last.dow_map.length - 1] <= this.theDate.getDay())
                this._last.dow_map.pop()
        }

        if (this._bydayoffset != 0) {
            while (this._last.month < startDate.getMonth())
                this._last.month = this._last.month_list.pop()
            this._last.day = 1
        }

        while ((this.theDate < startDate) && ok) {
            ok = this.next()
        }
        if (ok) {
            dates.push(this.theDate);
            this.count--;
        }
        while (this.next() && this.theDate <= endDate && this.count > 0) {
            dates.push(this.theDate);
            if (this.theDate >= this.startDate)
                this.count--
        }
        return dates;
    }

    this.next = function () {
    }

    this._pushByMonth = function () {
        if (this._bymonth)
            this._last.month_list = this._bymonth.slice(0).reverse();
        else
            this._last.month_list = [11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0]; // january is month 0
    }

    this.mpy = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
    this._pushByMonthDay = function () {
        if (this._bymonthday)
            this._last.date_list = this._bymonthday.slice(0).reverse();
        else
            this._last.date_list = [31, 30, 29, 28, 27, 26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1];
        var mpy = this.mpy[this._last.month];
        if (this._last.month == 2 && this._last.year % 4 == 0)
            mpy += 1;
        // remove any dates that are out of range
        while (this._last.date_list[0] > mpy)
            this._last.date_list = this._last.date_list.splice(1, 1);
    }


    this._nextDaily = function () {
        // do daily steps
        var ok = false
        if (!this._byrules) {
            this.theDate = new Date(this.theDate.valueOf() + this._oneDay * 1000 * this.interval)
            ok = true;
        }
        else {
            // ok if there is a bymonth
            if (this._last.date_list.length == 0) {
                if (this._last.month_list.length == 0) // no more months either
                {
                    // increment the year
                    this._last.year++;
                    this._pushByMonth();
                }
                // pop the next month off the stack
                this._last.month = this._last.month_list.pop()
                this._pushByMonthDay()
            }
            // pop the day off the stack
            this._last.day = this._last.date_list.pop()
            // format the new time
            this.theDate = this._fromLast(); // new Date(this._last.year, this._last.month, this._last.day, this._last.hour, this._last.minute, this._last.second);
            ok = true;
        }
        return ok
    }

    this._nextWeekly = function () {
        var ok = false
        if (!this._byrules) {
            this.theDate = new Date(this.theDate.valueOf() + this._oneDay * 7 * 1000 * this.interval) // same date and time in interval*weeks
            ok = true;
        }
        else {
            if (this._last.dow_map.length == 0) {
                if (this.interval > 1) {
                    // this is every n weeks on the listed days
                    var delta = (this.interval * 7) - this.theDate.getDay()
                    this.theDate = new Date(this.theDate.valueOf() + (this._oneDay * delta * 1000)) // go to monday of week offset
                }
                this._last.dow_map = this._byday.slice(0)
            }
            var nextdow = this._last.dow_map.pop()
            while (this.theDate.getDay() != nextdow)
                this.theDate = new Date(this.theDate.valueOf() + this._oneDay * 1000) // go forward one day
            ok = true;
        }
        return ok;
    }

    this._nextMonthly = function () {
        // do monthly steps
        var ok = false
        if (!this._byrules) {
            // step forward interval * months
            this._setLastDate(this.theDate);
            this._last.month += this.interval;
            if (this._last.month > 11) {
                this._last.year++;
                this._last.month -= 12;
            }
            this.theDate = this._fromLast()
            ok = true;
        }
        else {
            if (this._last.date_list.length == 0) {
                this._setLastDate(this.theDate);
                this._last.month += this.interval;
                if (this._last.month > 11) {
                    this._last.year++;
                    this._last.month -= 12;
                }
                this.theDate = this._fromLast()
                if (this._bydayoffset == 0)
                    this._pushByMonthDay()
            }
            if (this._bydayoffset == 0)
                this._last.day = this._last.date_list.pop()
            else
                this._last.day = this._getOffsetDate()
            this.theDate = this._fromLast();
            ok = true;
        }
        return ok;
    }

    this._nextYearly = function () {
        // do Yearly steps
        var ok = false
        this._setLastDate(this.theDate);
        if (!this._byrules) {
            // step forward interval years
            this._last.year += this.interval;
        }
        else {
            // the yearly system expands all the rules
            if (this._last.date_list.length == 0) {
                // out of days
                if (this._bydayoffset == 0)
                    this._pushByMonthDay();
                if (this._last.month_list.length == 0) {
                    // go to next year
                    this._last.year += this.interval;
                    this._pushByMonth();
                }
                this._last.month = this._last.month_list.pop();
            }
            if (this._bydayoffset == 0)
                this._last.day = this._last.date_list.pop()
            else
                this._last.day = this._getOffsetDate()
        }
        this.theDate = this._fromLast()
        ok = true;
        return ok;
    }

    this._getOffsetDate = function () {
        this._last.day = 1 // go to first of month
        var os = this._bydayoffset
        if (this._bydayoffset > 0) { // going forwards
            var d = this._fromLast()
            var dow = (this._bydayindex - d.getDay());
            if (dow < 0)
                dow += 7
            var weekoffset = (this._bydayoffset - 1) * 7
            this._last.day = 1 + weekoffset + dow
            d = this._fromLast();
        }
        else { // going backwards
            // go to the first day of the next month
            this._last.month++;
            this._last.day = 1;
            if (this._last.month > 11) {
                this._last.month -= 12;
                this._last.year++;
            }

            // then move back one day to the end of the previous month
            var d = this._fromLast()
            d = new Date(d.valueOf() - 86400000)
            var dow = d.getDay();
            this._setLastDate(d)
            for (this._last.day; this._last.day > 1; this._last.day--) {
                if (dow == this._bydayindex) {
                    os++;
                    if (os == 0) {
                        // this is the right day and offset
                        return this._last.day;
                    }
                }
                dow = (dow + 13) % 7;
            }
        }
        return this._last.day
    }


    this._expandBy = function (by) {
        var myby = []
        myby = by.split(',')
        for (var i = 0; i < myby.length; i++)
            myby[i] = parseInt(myby[i])
        this._byrules = myby.length > 0
        return myby;
    }

    this._expandByDayForWeekly = function () {
        // add day of week numbers for reverse pull off
        var days = []
        if (this.rrule["BYDAY"]) {
            days = this.rrule["BYDAY"].slice(0).split(',')
            for (var i = 0; i < days.length; i++) {
                if (days[i] == "SU") days[i] = 0
                if (days[i] == "MO") days[i] = 1
                if (days[i] == "TU") days[i] = 2
                if (days[i] == "WE") days[i] = 3
                if (days[i] == "TH") days[i] = 4
                if (days[i] == "FR") days[i] = 5
                if (days[i] == "SA") days[i] = 6
            }
            days.sort()
            days = days.reverse()
        }
        return days
    }

    this._setLastDate = function (dt) {
        this._last.year = dt.getFullYear()
        this._last.month = dt.getMonth()
        this._last.day = dt.getDate();
        this._last.hour = dt.getHours();
        this._last.minute = dt.getMinutes();
        this._last.second = dt.getSeconds();
    }

    this._fromLast = function () {
        return new Date(this._last.year, this._last.month, this._last.day, this._last.hour, this._last.minute, this._last.second, 0);
    }
}


var ev = [  
//    { text: "FREQ=DAILY;INTERVAL=3;COUNT=6;", start_date: new Date() },
//    { text: "FREQ=DAILY;INTERVAL=2;COUNT=6;BYMONTH=1,3,5,7,9;BYMONTHDAY=15,18,21", start_date: new Date() },
//    { text: "FREQ=WEEKLY;INTERVAL=2;COUNT=4", start_date: new Date() },
//    { text: "FREQ=WEEKLY;INTERVAL=2;COUNT=6;BYDAY=MO,WE,FR;UNTIL=20130721T0000", start_date: new Date() },
//    { text: "FREQ=MONTHLY;INTERVAL=2;COUNT=4", start_date: new Date() },
//    { text: "FREQ=MONTHLY;INTERVAL=2;COUNT=10;BYMONTHDAY=3,8,12,17,21", start_date: new Date() },
//    { text: "FREQ=YEARLY;INTERVAL=2;COUNT=4", start_date: new Date() },
//    { text: "FREQ=YEARLY;INTERVAL=2;COUNT=20;BYMONTH=5,7,12;BYMONTHDAY=12,18,21", start_date: new Date() },
//    {text: "FREQ=YEARLY;BYMONTH=7;BYMONTHDAY=21;COUNT=10", start_date: new Date() },
]

var ici=new icalIterator();
for (var ix=0;ix<ev.length;ix++)
{
    ici.init(ev[ix])
    var dates = ici.getDates(new Date(2011, 0, 1), new Date(2050, 0, 1))
    for (var i = 0; i < dates.length; i++)
        debug(dates[i])
}
debug("Done!")







scheduler.repeat_date = function (ev, stack, non_render, from, to) {
    from = from || this._min_date;
    to = to || this._max_date;

    // calculate the dates for this event that are in range
    if (!ev.icaldates)
        ev.icaldates = []
    if (ev.icaldates.length == 0)
        scheduler.initEventEndDates(ev);
    for (var i = 0; i < ev.icaldates.length; i++) {
        var td = ev.icaldates[i]
        if (td < from)
            continue;
        if (td > to)
            break;
        var timestamp = (scheduler.config.occurrence_timestamp_in_utc) ? Date.UTC(td.getFullYear(), td.getMonth(), td.getDate(), td.getHours(), td.getMinutes(), td.getSeconds()) : td.valueOf();
        // look for an override event
        var ch = this._get_rec_marker(timestamp, ev.id);
        if (!ch) { // unmodified element of series
            var ted = new Date(td.valueOf() + ev.event_length * 1000);
            var copy = this._copy_event(ev);
            //copy._timed = ev._timed;
            copy.text = ev.text;
            copy.start_date = td;
            copy.event_pid = ev.id;
            copy.id = ev.id + "#" + Math.ceil(timestamp / 1000);
            copy.end_date = ted;

            copy.end_date = scheduler._fix_daylight_saving_date(copy.start_date, copy.end_date, ev, td, copy.end_date);

            copy._timed = this.is_one_day_event(copy);

            if (!copy._timed && !this._table_view && !this.config.multi_day) return;
            stack.push(copy);

            if (!non_render) {
                this._events[copy.id] = copy;
                this._rec_temp.push(copy);
            }

        } else
            if (non_render) stack.push(ch);
    }
};
