function padDate(k)
{
    if (k<10)
        return "0"+k
    return k
}

function toUtc(dt) {
    var t = ""
    t += dt.getUTCFullYear()
    t += padDate(dt.getUTCMonth()+1);
    t += padDate(dt.getUTCDate())
    t += "T";
    t += padDate(dt.getUTCHours());
    t += padDate(dt.getUTCMinutes());
    t += padDate(dt.getUTCSeconds());
    t += "Z"
    return t
}


function ToICal(id, ev) {
    //var folder = currentFolder
    var format = scheduler.date.date_to_str("%Y%m%dT%H%i%s");
    var full_day_format = scheduler.date.date_to_str("%Y%m%d");

    var ical = [];
    ical.push("BEGIN:VEVENT");
    if (!ev.allday) {
        ical.push("DTSTART:" + toUtc(ev.start_date))
        ical.push("DTEND:" + toUtc(ev.end_date));
    }
    else {
        ical.push("DTSTART:" + full_day_format(ev.start_date))
        var dt=new Date(ev.end_date.valueOf()-86400000)
        ical.push("DTEND:" + full_day_format(dt));
    }

    if (ev.event_length && !ev.allday) {
        // convert length to duration
        var d = ev.event_length;
		duration="P";
		var dy=d/86400;
		d-=(d/86400)*86400;
		var hr=d/3600;
		d-=(d/3600)*3600;
		var min=d/60;
		d-=(d/60)*60;
		ical.push("DURATION:P"+dy+"DT"+hr+"H"+min+"M"+d+"S");
    }
    if (ev.attendee) {
        for (var i = 0; i < ev.attendee.length; i++)
            ical.push("ATTENDEE:" + ev.attendee[i])
    }
    ical.push("ORGANIZER:" + ev.organizer);
    ical.push("SUMMARY:" + ev.text);
    ical.push("UID:" + id)
    ical.push("CREATED:" + toUtc(new Date))
    ical.push("DESCRIPTION:"+ev.description)
    ical.push("LOCATION:" + ev.location)
    var seq = parseInt(ev.sequence)
    if (seq == NaN)
        seq = 0;
    seq++
    ical.push("SEQUENCE:" + seq);
    if (ev.rrule) {
        ical.push("RRULE:" + ev.rrule);
    }
    if (ev.until) {
        ical.push("until:"+full_day_format(ev.until))
    }
    ical.push("CATEGORIES:" + ev.categories);
    ical.push("PRIORITY:" + ev.priority);
    ical.push("X-TYPE:" + ev.type);
    ical.push("X-TZOFFSET:" + ev["x-tzoffset"]);
    ical.push("X-TZNAME:" + ev["x-tzname"]);
    ical.push("STATUS:" + ev.status);
    if (ev.valarm && ev.valarm.length > 0) {
        ical.push("BEGIN:VALARM")
        ical.push(ev.valarm.join("\n"))
        if (ev.valarm.completed.length)
            ical.push(ev.valarm.completed.join("\n"));
        ical.push("END:VALARM")
    }

    ical.push("TRANSP:TRANSPARENT");
    ical.push("END:VEVENT");
    return ical.join("\n")
}









function EventDeleted(event_id, ev) {
    dhtmlxAjax.post("/v7/axml/ical.fts?fid=" + NormaliseFolderId(currentFolder) + "&delete=" + event_id);
}


function show_minical() {
    if (scheduler.isCalendarVisible())
        scheduler.destroyCalendar();
    else
        scheduler.renderCalendar({
            position: "dhx_minical_icon",
            date: scheduler._date,
            navigation: true,
            handler: function (date, calendar) {
                scheduler.setCurrentView(date);
                scheduler.destroyCalendar()
            }
        });
}

function BuildRecur(type, count, day, count2, days, extra) {
    var str = type + '_' + count + '_' + day + '_' + count2 + '_' + days + '_' + extra
    return str

}

scheduler.initEventEndDates = function (ev) {
    var ici = new icalIterator();
    if (ici.init(ev)) {
        var dt = new Date;
        dt.setFullYear(dt.getFullYear() + 1) // look 1 years ahead
        ev.icaldates = ici.getDates(ev.start_date, dt)
        //if (ev.icaldates.length > 0) {
          //  ev.end_date = ev.icaldates[ev.icaldates.length - 1]
        //}
    }
    //else
    //    ev.end_date = new Date(ev.dtstart.valueOf() + ev.duration * 1000)
    ici=0
}

scheduler.ical = {
    parse: function (str) {
        var data = str.match(RegExp(this.c_start + "[^\f]*" + this.c_end, ""));
        if (data == undefined || data.length == 0) return;

        //unfolding 
        data[0] = data[0].replace(/[\r\n]+(?=[a-z \t])/g, " ");

        var incoming = [];
        var match;
        var event_r = RegExp("(?:" + this.e_start + ")([^\f]*?)(?:" + this.e_end + ")", "g");
        var alert_r = RegExp("(?:BEGIN:VALARM)([^\f]*?)(?:END:VALARM)", "g");
        while (match = event_r.exec(data)) {
            var e = {}
            var valarm
            // extract the alarm data (if any)
            /*
            var valarmstart = match[1].indexOf("BEGIN:VALARM")
            if (valarmstart != -1) {
            var valarmend = match[1].indexOf("END:VALARM\n", valarmstart)
            if (valarmend != -1) {
            valarm = match[1].substr(valarmstart, valarmend-valarmstart + 11);
            match[1] = match[1].replace(valarm, "");
            }
            }
            */
            e.allday = false
            e.event_length = 0;
            e.text = "Event"
            e.dtstart = Date
            e.dtend = 0
            e.duration = 0
            e.organizer = "";
            e.sequence = 0
            e["x-tzname"] = activetzname
            e.attendee = []
            e.subsection = ""
            e.completed = []
            var param;
            var param_r = /[^\r\n]+[\r\n]+/g;
            while (param = param_r.exec(match[1]))
                this.parse_param(param.toString(), e);
            if (e.valarm) {
                var alarmtemp = e.valarm.join("\n") + "\nPADDING:1"
                e.valarm = {}
                e.valarm.subsection = "";
                e.valarm.attendee = []
                e.valarm.completed = []
                while (param = param_r.exec(alarmtemp))
                    this.parse_param(param.toString(), e.valarm);
            }

            if (e.uid && !e.id) e.id = e.uid; //fallback to UID, when ID is not defined
            // need to see if its recurring and if so
            // modify its end date
            if (e.attendee.length == 0)
                delete e.attendee
            delete e.subsection
            if (e.dtend && e.dtstart) {
                if (e.duration == 0)
                    e.duration = Math.floor((e.dtend.valueOf() - e.dtstart.valueOf()) / 1000)
                else
                    if (e.rrule && e.duration > 86400 * 28) {
                        e.duration = 86400
                        e.dtend = new Date(e.dtstart.valueOf() + e.duration * 1000)
                    }
            }
            if (e.allday) {
                e.dtend = new Date(e.dtend.valueOf() + 86400000);
            }
            if (e.event_length == 0)
                e.event_length = e.duration
            scheduler.initEventEndDates(e)
            incoming.push(e);
        }
        return incoming;
    },
    parse_param: function (str, obj) {
        var d = str.indexOf(":");
        if (d == -1) return;

        var name = str.substr(0, d).toLowerCase();
        name = name.split(';')[0]
        var value = str.substr(d + 1).replace(/\\\,/g, ",").replace(/[\r\n]+$/, "");
        if (name == "begin") {
            obj.subsection = value.toLowerCase();
            obj[obj.subsection] = []
            return
        }
        if (obj.subsection != "") {
            if (name == "end")
                obj.subsection = ""
            else
                obj[obj.subsection].push(str.trim())
            return;
        }
        if (name == "summary")
            name = "text";
        if (name == "x-type")
            name = "type";
        if (name == "x-allday") {
            obj.allday = true;
            return;
        }
        if (name == "completed") {
            obj.completed.push(value);
            return;
        }
        if (str.substr(0, 9) == "ATTENDEE;") {
            obj.attendee.push(str.substr(9, 9999))
            return;
        }
        if (name == "attendee") {
            obj.attendee.push(value)
            return;
        }
        if (name == "rrule") {
            if (value.indexOf("FREQ") == -1)
                return;
            var s = value.indexOf("UNTIL=");
            if (s != -1) {
                var until = this.parse_date(value.slice(s + 6, 9999), 0, 0);
                if (isNaN(until.getTime()))
                    until = new Date
                obj["until"] = until;
            }
        }
        else if (name == "dtstart") {
            name = "start_date";
            obj["allday"] = value.length == 8;
            value = this.parse_date(value, 0, 0);
            if (isNaN(value.getTime()))
                value = new Date
            obj["dtstart"] = value
        }
        else if (name == "dtend") {
            if (value.indexOf("NaN") != -1)
                value = "20200101"
            value = this.parse_date(value, 0, 0);
            if (isNaN(value.getTime()))
                value = new Date
            obj["dtend"] = value
            name = "end_date";
        }
        else if (name == "x-tzoffset") {
            value = parseInt(value)
        }
        else if (name == "x-recpattern") {
            //name = "rec_pattern"
        }
        else if (name == "x-rectype") {
            //name = "rec_type"
            //obj["_timed"] = true;
        }
        else if (name == "CATEGORY") {
            name = "CATEGORIES"
        }
        else if (name == "duration") {
            name = "event_length"
            obj["_timed"] = true;
            // convert value from string to number
            value = value.replace("P", "P\n")
            value = value.replace("D", "D\n")
            value = value.replace("T", "T\n")
            value = value.replace("H", "H\n")
            value = value.replace("M", "M\n")
            value = value.replace("S", "S\n")
            var valstr = value.split("\n");
            value = 0;
            for (i = 0; i < valstr.length; i++) {
                var t = valstr[i].slice(-1);
                var v = parseInt(valstr[i]);
                if (t == "D")
                    value += v * 86400;
                if (t == "H")
                    value = value + v * 3600;
                if (t == "M")
                    value = value + v * 60;
                if (t == "S")
                    value += v;
            }
            obj["duration"] = value;
        }

        obj[name] = value;
    },
    parse_date: function (value, dh, dm) {
        var isUTC = value.indexOf('Z') != -1
        var t = value.split("T");
        if (t[1]) {
            dh = t[1].substr(0, 2);
            dm = t[1].substr(2, 2);
        }
        var dy = t[0].substr(0, 4);
        var dn = parseInt(t[0].substr(4, 2), 10) - 1;
        var dd = t[0].substr(6, 2);
        if (isUTC)
            return new Date(Date.UTC(dy, dn, dd, dh, dm));
        return new Date(dy, dn, dd, dh, dm);
    },
    c_start: "BEGIN:VCALENDAR",
    e_start: "BEGIN:VEVENT",
    e_end: "END:VEVENT",
    c_end: "END:VCALENDAR"
};

scheduler.templates.agenda_text = function (start, end, ev) {
    var text = ev.text
    if (ev["x-tzname"] && ev["x-tzname"] != activetzname)
        text+=" ("+ev["x-tzname"]+")"
    if (ev.priority == 0)
        text = '<font color="gray">' + ev.text + '</font>'
    if (ev.priority == 2)
        text = '<font color="red">' + ev.text + '</font>'
    if (ev.rrule) {
        // append the recurring icon
        text=text+' <img src="/images/recur.gif"/>'
    }
    return text
}

scheduler.templates.agenda_time = function (start, end, ev) {
    var duration = (end.valueOf() - start.valueOf())
    // 3 options
    // all day event (show date only)
    if (ev.duration == 86400 || ev.allday)
        return ev.start_date.toLocaleDateString()
    // event that is part of a day (show date and time)
    if (ev.duration < 86400)
        return ev.start_date.toLocaleDateString() + " " + ev.start_date.toLocaleTimeString().slice(0, 5)
    // event that covers more than one day (show start and end dates)
    // if its an all day event, then apply adjustment to display times
    var dt = ev.end_date;
    if (ev.allday)
        dt=new Date(dt.valueOf()-86400000)
    return ev.start_date.toLocaleDateString() + " &ndash; " + dt.toLocaleDateString();
};


scheduler.render_view_data = function () {
    if (this._not_render) {
        this._render_wait = true;
        return;
    }
    this._render_wait = false;

    this.clear_view();
    var evs = this.get_visible_events();

    if (this.config.multi_day && !this._table_view) {
        var tvs = [];
        var tvd = [];
        for (var i = 0; i < evs.length; i++) {
            var ev = evs[i]
            ev.earlystart = ev.start_date.getHours() < scheduler.config.first_hour
            if (ev._timed && !ev.earlystart)
                tvs.push(evs[i]);
            else
                tvd.push(evs[i]);
        };
        this._table_view = true;
        this.render_data(tvd);
        this._table_view = false;
        this.render_data(tvs);
    } else
        this.render_data(evs);
};

scheduler.render_event_bar = function (ev) {
    var parent = this._els["dhx_cal_data"][0];

    var x = this._colsS[ev._sday];
    var x2 = this._colsS[ev._eday];
    if (x2 == x) x2 = this._colsS[ev._eday + 1];
    var hb = this.xy.bar_height;

    var y = this._colsS.heights[ev._sweek] + (this._colsS.height ? (this.xy.month_scale_height + 2) : 2) + ev._sorder * hb;

    var d = document.createElement("DIV");
    var cs = (ev._timed && !ev.earlystart) ? "dhx_cal_event_clear" : "dhx_cal_event_line";
    var cse = scheduler.templates.event_class(ev.start_date, ev.end_date, ev);
    if (cse) cs = cs + " " + cse;

    var html = '<div event_id="' + ev.id + '" class="' + cs + '" style="position:absolute; top:' + y + 'px; left:' + x + 'px; width:' + (x2 - x - 15) + 'px;' + (ev._text_style || "") + '">';

    if (ev._timed)
        html += scheduler.templates.event_bar_date(ev.start_date, ev.end_date, ev);
    html += scheduler.templates.event_bar_text(ev.start_date, ev.end_date, ev) + '</div>';
    html += '</div>';

    d.innerHTML = html;

    this._rendered.push(d.firstChild);
    parent.appendChild(d.firstChild);
};
scheduler.currentRights="r"
scheduler.addEventNowA=scheduler.addEventNow
scheduler.addEventNow = function (start, end, e) {
    if (scheduler.currentRights.indexOf("w")!=-1)
        return scheduler.addEventNowA(start, end, e)
}
scheduler.get_visible_events_rec = function (a) {
    var b = [], c;
    for (c in this._events) {
        //for each event look to see if its recurring and in the visible time slot for the event.
        var ev = this._events[c];
        if (ev.rrule) {
            for (i = 0; i < ev.icaldates.length; i++) {
                if (ev.icaldates[i] >= this._min_date && ev.icaldates[i] <= this._max_date) {
                    b.push(ev);
                    break;
                }
            }
        }
        else
            this.is_visible_events(ev) && (!a || ev._timed) && this.filter_event(c, ev) && b.push(ev);
    }
    return b
}

scheduler.get_visible_events = function (a) {
    for (var b = 0; b < this._rec_temp.length; b++)
        delete this._events[this._rec_temp[b].id]; this._rec_temp = [];

    for (var c = this.get_visible_events_rec(a), d = [], b = 0; b < c.length; b++) 
        c[b].rec_type ? c[b].rec_pattern != "none" && this.repeat_date(c[b], d) : d.push(c[b]);
    return d 
    };