Date.prototype.stdTimezoneOffset = function() {
    var jan = new Date(this.getFullYear(), 0, 1);
    var jul = new Date(this.getFullYear(), 6, 1);
    return Math.max(jan.getTimezoneOffset(), jul.getTimezoneOffset());
}

Date.prototype.dst = function() {
    return this.getTimezoneOffset() < this.stdTimezoneOffset();
}

Date.prototype.correctTZ = function()
{
    var time=this.getTime();
    var nowDt = new Date()
    if (nowDt.dst()) 
        time -= 3600000;
    time-=nowDt.getTimezoneOffset() * 60000;
    return new Date(time);
}

function eXcell_dtICal(cell) {                             //excell name is defined here
    if (cell) {                                                     //default pattern, just copy it
        this.cell = cell;
        this.grid = this.cell.parentNode.grid;
    }
    this.edit = function () { }                                //read-only cell doesn't have edit method
    this.isDisabled = function () { return true; }      // the cell is read-only, that's why it is always in the disabled state
    this.setValue = function (val) {
        var row_id = this.cell.parentNode.idd;     //get related row id
        if (val == "") {
            this.setCValue(tmxlang["_none"], val);
            return;
        }
        var dt=FromICalDate(val)
        var nowDt = new Date()
        if (nowDt.getDate() == dt.getDate() && nowDt.getMonth() == dt.getMonth() && nowDt.getYear() == dt.getYear())
            this.setCValue(dt.toLocaleTimeString(), val);
        else
            this.setCValue(dt.toLocaleDateString(), val);
    }
}
eXcell_dtICal.prototype = new eXcell;    // nest all other methods

function FromICalDate(val) {
    y = val.slice(0, 4)
    m = val.slice(4, 6) - 1
    d = val.slice(6, 8)
    hr = val.slice(9, 11)
    mn = val.slice(11, 13)
    ss = val.slice(13, 15)
    var dt = new Date(y, m, d, hr, mn, ss)
    dt=dt.correctTZ();
    return dt;
}

function eXcell_niceBytes(cell) {                             //excell name is defined here
    if (cell) {                                                     //default pattern, just copy it
        this.cell = cell;
        this.grid = this.cell.parentNode.grid;
    }
    this.edit = function () { }                                //read-only cell doesn't have edit method
    this.isDisabled = function () { return true; }      // the cell is read-only, that's why it is always in the disabled state
    this.setValue = function (val) {
        var row_id = this.cell.parentNode.idd;     //get related row id
        bytes=0
        if (val < 1024)
            bytes= val;
        else if (val < 1024 * 1024)
            bytes = Math.round(val / 1024, 1) + "Kb";
        else if (val < 1024 * 1024 * 1024)
            bytes = Math.round(val / (1024 * 1024), 10) + "Mb";
        else
            bytes = Math.round(val / (1024 * 1024 * 1024), 100) + "Gb";
        this.setCValue(bytes, val);
    }
}
eXcell_niceBytes.prototype = new eXcell;    // nest all other methods


function eXcell_dtCol(cell) {                             //excell name is defined here
    if (cell) {                                                     //default pattern, just copy it
        this.cell = cell;
        this.grid = this.cell.parentNode.grid;
    }
    this.edit = function () { }                                //read-only cell doesn't have edit method
    this.isDisabled = function () { return true; }      // the cell is read-only, that's why it is always in the disabled state
    this.setValue = function (val) {
        var row_id = this.cell.parentNode.idd;     //get related row id
        y = val.slice(0, 4)
        m = val.slice(5, 7) - 1
        d = val.slice(8, 10)
        hr = val.slice(11, 13)
        mn = val.slice(14, 16)
        ss = val.slice(17, 20)
        var dt = new Date(y, m, d, hr, mn, ss)
        dt = dt.correctTZ();
        var nowDt = new Date()
        if (nowDt.getDate() == dt.getDate() && nowDt.getMonth() == dt.getMonth() && nowDt.getYear() == dt.getYear())
            this.setCValue(dt.toLocaleTimeString(), val);
        else
            this.setCValue(dt.toLocaleDateString(), val);
    }
}
eXcell_dtCol.prototype = new eXcell;    // nest all other methods

function eXcell_dtCol2(cell) {                             //excell name is defined here
    if (cell) {                                                     //default pattern, just copy it
        this.cell = cell;
        this.grid = this.cell.parentNode.grid;
    }
    this.edit = function () { }                                //read-only cell doesn't have edit method
    this.isDisabled = function () { return true; }      // the cell is read-only, that's why it is always in the disabled state
    this.setValue = function (val) {
        var row_id = this.cell.parentNode.idd;     //get related row id
        y = val.slice(0, 4)
        m = val.slice(5, 7) - 1
        d = val.slice(8, 10)
        hr = val.slice(11, 13)
        mn = val.slice(14, 16)
        ss = val.slice(17, 19)
        var val2 = val.slice(19);
        var dt = new Date(Date.UTC(y, m, d, hr, mn, ss))
        //dt = dt.correctTZ();
        var nowDt = new Date()
        if (nowDt.getDate() == dt.getDate() && nowDt.getMonth() == dt.getMonth() && nowDt.getYear() == dt.getYear())
            this.setCValue(dt.toLocaleTimeString() + val2, val);
        else
            this.setCValue(dt.toLocaleDateString() + val2, val);
    }
}
eXcell_dtCol2.prototype = new eXcell;    // nest all other methods

function eXcell_dtCol3(cell) {                             //excell name is defined here
    if (cell) {                                                     //default pattern, just copy it
        this.cell = cell;
        this.grid = this.cell.parentNode.grid;
    }
    this.edit = function () { }                                //read-only cell doesn't have edit method
    this.isDisabled = function () { return true; }      // the cell is read-only, that's why it is always in the disabled state
    this.setValue = function (val) {
        var row_id = this.cell.parentNode.idd;     //get related row id
        y = val.slice(0, 4)
        m = val.slice(5, 7) - 1
        d = val.slice(8, 10)
        hr = val.slice(11, 13)
        mn = val.slice(14, 16)
        ss = val.slice(17, 19)
        var val2 = val.slice(19);
        var dt = new Date(y, m, d, hr, mn, ss)
        dt.setUTCFullYear(y)
        dt.setUTCMonth(m)
        dt.setUTCDate(d)
        dt.setUTCHours(hr)
        dt.setUTCMinutes(mn)
        dt.setUTCSeconds(ss)
        dt = dt.correctTZ();
        var nowDt = new Date()
        if (nowDt.getDate() == dt.getDate() && nowDt.getMonth() == dt.getMonth() && nowDt.getYear() == dt.getYear())
            this.setCValue(dt.toLocaleTimeString() + val2, val);
        else {
            if (dt.getMinutes() > 9)
                this.setCValue(dt.toLocaleDateString() + val2 + " " + dt.getHours() + ":" + dt.getMinutes(), val);
            else
                this.setCValue(dt.toLocaleDateString() + val2 + " " + dt.getHours() + ":0" + dt.getMinutes(), val);

        }
    }
}
eXcell_dtCol3.prototype = new eXcell;    // nest all other methods

function SortDateCustom(a, b, order, ra, rb) {
    a1 = mailGrid.getUserData(ra, 'time');
    b1 = mailGrid.getUserData(rb, 'time');
    if (a1 == b1)
        return 0
    return (a1 > b1 ? 1 : -1) * (order == "asc" ? 1 : -1);
}
