

dhtmlx.image_path = "/imgs/"

var allday = false;
var noend = false;
var theEvent;
var dtstart
var dtend
var completed = []
var organizer = ""
var sequence = 0
var uid = ""
var currentFreq = "";



function initUI() {
    organizer = theEvent.organizer;
    sequence = TryParseInt(theEvent.sequence, 0);
    if (theEvent.uid)
        uid = theEvent.uid;
    setValue('subject', theEvent["text"])
    setValue('description', theEvent["description"])
    setValue('location', theEvent["location"])
    if (theEvent.categories)
        setValue('categories', theEvent["categories"])
    if (theEvent.priority)
        setValue('priority', theEvent["priority"])
    if (theEvent["type"])
        setValue('type', theEvent["type"])
    if (theEvent["status"])
        setValue('status', theEvent["status"])

    // set the start times and lengths
    dtstart = theEvent["dtstart"] || new Date;
    // must have one or both of end/duration
    dtend = theEvent["dtend"]
    var duration = theEvent["duration"]
    if (dtend == undefined || dtend < dtstart)
        dtend = new Date(dtstart.valueOf() + duration * 1000)
    if (!duration == undefined)
        duration = (dtend.valueOf() - dtstart.valueOf()) / 1000

    if (theEvent.allday || duration == 86400) {
        document.getElementById('allday').checked = true;
        setValue('dtstart', dtstart.toLocaleDateString())
        dtend = new Date(dtend.valueOf() - 86400000) // go back one day for display purposes
        setValue('dtend', dtend.toLocaleDateString())
    }
    else {
        setValue('dtstart', toDateTimeString(dtstart))
        setValue('dtend', toDateTimeString(dtend))
    }
    myCalendar.setDate(dtstart.getFullYear() + '-' + (dtstart.getMonth() + 1) + "-" + dtstart.getDate())
    myCalendar2.setDate(dtend.getFullYear() + '-' + (dtend.getMonth() + 1) + "-" + dtend.getDate())
    myCalendar2.setSensitiveRange(dtstart.getFullYear() + '-' + (dtstart.getMonth() + 1) + "-" + dtstart.getDate(), null)
    // process attendees
    if (theEvent.attendee) {
        for (var k = 0; k < theEvent.attendee.length; k++) {
            // ATTENDEE:mailto:someone@somplace.com
            // ATTENDEE;RSVP=TRUE;CN=Bob Jones:mailto:dfgdfgdfgdf@Dfgdfgdfgd
            var str = theEvent.attendee[k];
            var s = str.indexOf(":");
            var decorator = str.slice(0, s);
            var mailto = str.slice(s + 1, 9999);
            var cn = ""
            var data = decorator.split(";");
            for (var i = 0; i < data.length; i++) {
                var parts = data[i].split("=")
                if (parts[0] == "CN") {
                    parts = parts[1].split(":")
                    cn = parts[0]
                    for (var j = 1; i < parts.length; parts++)
                        if (parts[j] == "mailto") {
                            mailto = parts[j + 1]
                            break;
                        }
                }
            }
            attendeeGrid.addRow(attendeeId++, ',' + cn + '[ ' + mailto + ' ]')
        }
    }


    // init the rrule frequency settings if there are any
    if (theEvent["rrule"]) {
        var rrule = theEvent["rrule"]
        var freq
        var bymonth
        var byday
        var bymonthday
        var interval
        var until
        var count
        rrule = rrule.split(";")
        for (var i = 0; i < rrule.length; i++) {
            var name = rrule[i].split("=")[0].toLowerCase()
            var data = rrule[i].split("=")[1]
            if (name == "freq")
                freq = data
            if (name == "bymonth") {
                bymonth = data.split(",")
                for (var j = 0; j < bymonth.length; j++)
                    document.getElementById('bymonth_' + bymonth[j]).checked = true
            }
            if (name == "bymonthday") {
                bymonthday = data.split(",")
                for (var j = 0; j < bymonthday.length; j++)
                    document.getElementById('bymonthday_' + bymonthday[j]).checked = true
            }
            if (name == "byday") {
                var t = data.slice(0, 1)
                var offsets = "-1234"
                if (offsets.indexOf(t) == -1) {
                    byday = data.split(",")
                    // two forms, either a list of dows
                    // or an offset and a dow
                    var days = ["SU", "MO", "TU", "WE", "TH", "FR", "SA"]
                    for (var j = 0; j < days.length; j++) {
                        if (data.indexOf(days[j]) != -1)
                            document.getElementById('byday' + (j + 1) + 'a').checked = true
                    }
                }
                else {
                    var bydayindex = 0
                    var bydayoffset = 0
                    if (t == "-") {
                        bydayoffset = data.slice(0, 2)
                        bydayindex = data.slice(2)
                    }
                    else {
                        this._bydayoffset = data.slice(0, 1)
                        this._bydayindex = data.slice(1)
                    }
                    //this._bydayoffset = parseInt(this._bydayoffset)
                    setValue('byweekday2', this._bydayindex)
                    setValue('byweekday2a', this._bydayoffset)
                }
            }
            if (name == "interval")
                byinterval = data
            if (name == "count")
                count = data
            if (name == "until") {
                until = data
                udate=theEvent["until"];
                myCalendar3.setDate(udate.getFullYear() + '-' + (udate.getMonth() + 1) + "-" + udate.getDate())
                CalendarChanged3(udate)
            }
        }
        if (count) {
            setValue("rec_endtype", 2)
            setValue("count", count)
        }
        if (until)
            setValue("rec_endtype", 1)
        if (freq == "MONTHLY")
            freq = bymonthday ? "MONTHLY1" : "MONTHLY2"
        if (freq == "YEARLY")
            freq = bymonthday ? "YEARLY" : "YEARLY2"
        currentFreq = freq;
        setValue("freq", freq)


        updateRecurrence()
    }
    if (theEvent.valarm) {
        setValue('alarm_time', theEvent.valarm.trigger)
        editor2.setContent(theEvent.valarm.description)
        completed = theEvent.valarm.completed || [];
    }
}


function debug(log_txt) {
    if (false && typeof window.console != 'undefined') {
        console.log(log_txt);
    }
}

function initFromEvent(event) {
    theEvent = event
    if (event.isnew) {
        event.dtstart = event.start_date
        event.dtend = event.end_date
    }
    setTimeout("initUI()", 10)
}

function TryParseInt(str, defaultValue) {
    var retValue = defaultValue;
    if (typeof (str) != "undefined") {
        if (str !== null) {
            if (str.length > 0) {
                if (!isNaN(str)) {
                    retValue = parseInt(str);
                }
            }
        }
    }
    return retValue;
}

function BuildRecurrenceRule() {
    var freq = getValue('freq')
    var interval = getValue('interval')
    var byday1 = []
    var i
    var days = ["SU", "MO", "TU", "WE", "TH", "FR", "SA"]
    for (i = 1; i < 8; i++) {
        if (document.getElementById('byday' + i + 'a').checked) byday1.push(days[i]);
    }
    byday1 = byday1.join(',')
    var byday2 = getValue("byweekday2a") + getValue("byweekday2")
    var bymonthday = []
    for (var i = 1; i < 32; i++)
        if (document.getElementById("bymonthday_" + i).checked) bymonthday.push(i)
    bymonthday = bymonthday.join(',')
    var bymonth = []
    for (var i = 1; i < 13; i++)
        if (document.getElementById("bymonth_" + i).checked) bymonth.push(i)
    bymonth = bymonth.join(',')
    var endtype = getValue('rec_endtype')
    var until = myCalendar3.getDate()
    var count = getValue('count')

    var rrule = []
    if (freq == "DAILY1") {
        rrule.push("FREQ=DAILY")
        if (byday1 != "")
            rrule.push("BYDAY=" + byday1)
    }
    if (freq == "DAILY") {
        rrule.push("FREQ=DAILY")
        if (interval > 0)
            rrule.push("INTERVAL=" + interval)
        //if (byday1!="")
        //rrule.push("BYDAY="+byday1)
    }
    if (freq == "WEEKLY") {
        rrule.push("FREQ=WEEKLY")
        if (interval > 0)
            rrule.push("INTERVAL=" + interval)
        if (byday1 != "")
            rrule.push("BYDAY=" + byday1)
    }
    if (freq == "MONTHLY1") {
        rrule.push("FREQ=MONTHLY")
        if (interval > 0)
            rrule.push("INTERVAL=" + interval)
        if (bymonthday != "")
            rrule.push("BYMONTHDAY=" + bymonthday)
    }
    if (freq == "MONTHLY2") {
        rrule.push("FREQ=MONTHLY")
        if (byday2 != "")
            rrule.push("BYDAY=" + byday2)
        if (bymonth != "")
            rrule.push("BYMONTH=" + bymonth)
    }
    if (freq == "YEARLY") {
        rrule.push("FREQ=YEARLY")
        if (interval > 0)
            rrule.push("INTERVAL=" + interval)
        if (bymonthday != "")
            rrule.push("BYMONTHDAY=" + bymonthday)
        if (bymonth != "")
            rrule.push("BYMONTH=" + bymonth)
    }
    if (freq == "YEARLY2") {
        rrule.push("FREQ=YEARLY")
        if (interval > 0)
            rrule.push("INTERVAL=" + interval)
        if (byday2 != "")
            rrule.push("BYDAY=" + byday2)
        if (bymonth != "")
            rrule.push("BYMONTH=" + bymonth)
    }
    if (endtype == 1) {
        rrule.push("UNTIL=")
    }
    if (endtype == 2)
        rrule.push("COUNT=" + count)
    rrule = rrule.join(';')
    return rrule
}


function padNum(k) {
    if (k < 10)
        return "0" + k
    return k
}

function toUtc(dt) {
    var t = ""
    t += dt.getUTCFullYear()
    t += padNum(dt.getUTCMonth() + 1);
    t += padNum(dt.getUTCDate())
    t += "T";
    t += padNum(dt.getUTCHours());
    t += padNum(dt.getUTCMinutes());
    t += padNum(dt.getUTCSeconds());
    t += "Z"
    return t
}

function DoSave() {
    // write all the data back to the event
    // then tall the main page
    theEvent["uid"] = uid;
    var tzoffset = 0 - new Date().getTimezoneOffset() // make this the offset from utc
    theEvent["x-tzoffset"] = tzoffset
    var tz = jstz.determine(); // Determines the time zone of the browser client
    theEvent["x-tzname"] = tz.name();
    theEvent.organizer = organizer;




    theEvent["text"] = getValue('subject')
    desc = getValue('description')
    if (desc != undefined && desc != "" && desc != "undefined")
        theEvent["description"] = desc
    theEvent["location"] = getValue('location')
    theEvent["categories"] = getValue('categories')
    theEvent["priority"] = getValue('priority')
    theEvent["type"] = getValue('type')
    theEvent["status"] = getValue('status')
    theEvent["sequence"] = sequence + 1
    theEvent.allday = false;
    if (document.getElementById('allday').checked) {
        theEvent.allday = true;
        dtstart.setHours(0)
        dtstart.setMinutes(0)
        dtstart.setSeconds(0)
        dtstart.setMilliseconds(0)
        if (dtstart.getFullYear() == dtend.getFullYear() && dtstart.getMonth() == dtend.getMonth() && dtstart.getDate() == dtend.getDate())
            dtend = new Date(dtstart.valueOf() + 86400000)
        else {
            dtend.setHours(0)
            dtend.setMinutes(0)
            dtend.setSeconds(0)
            dtend.setMilliseconds(0)
            dtend = new Date(dtend.valueOf() + 86400000);
        }
    }

    var duration = (dtend.valueOf() - dtstart.valueOf()) / 1000;
    // store the start and duration
    theEvent["dtstart"] = dtstart
    theEvent["start_date"] = dtstart
    //theEvent["duration"]=duration;
    theEvent["event_length"] = duration;
    theEvent["end_date"] = dtend;
    theEvent["dtend"] = undefined
    // store any attendees
    theEvent.attendee = []
    attendeeGrid.forEachRow(function (id) {
        var data = attendeeGrid.cells(id, 1).getValue()
        // split the data into the CN and MAILTO parts
        var cn = ""
        var mailto = ""
        data = data.split('[')
        if (data.length == 1)
            mailto = data[0]
        else {
            cn = data[0].trim()
            mailto = data[1].replace("]", "").trim()
        }
        theEvent.attendee.push("CN=" + cn + ":mailto:" + mailto)
    });
    // store the alarm
    theEvent.valarm = []
    var alarmTime = getValue('alarm_time');
    //var doAlert=document.getElementById('send_im').checked
    //var doEmail=document.getElementById('send_email').checked
    if (alarmTime != "none")//doAlert || doEmail)
    {
        theEvent.valarm.push("TRIGGER:" + getValue('alarm_time'))
        //theEvent.valarm.push("SUMMARY:"+getValue('subject'))
        theEvent.valarm.push("ACTION:EMAIL")
        desc = editor2.getContent()
        if (desc != undefined && desc != "" && desc != "undefined")
            theEvent.valarm.push("DESCRIPTION:" + desc)
        theEvent.valarm.attendee = theEvent.attendee.slice(0)
        theEvent.valarm.completed = []
        for (var i = 0; i < completed.length; i++)
            theEvent.valarm.completed.push("COMPLETED:" + completed[i]);
    }


    // store the recurrence data
    var freq = getValue("freq")
    delete theEvent.rrule
    if (freq != "none") {
        // have to build the recuurence string
        theEvent["rrule"] = BuildRecurrenceRule();
        theEvent["until"] = until.value;
    }
    theEvent.icaldates = []

    //
    top.FireEvent('onCalEditorSave', theEvent)
    top.CloseDialog()
}



function setValue(id, value) {
    if (value == undefined)
        value = ""
    document.getElementById(id).value = value;
}

function getValue(id) {
    return document.getElementById(id).value;
}

var tabbar
var editor1
var editor2
var attendeeGrid
var myCalendar
var myCalendar2
var myCalendar3
var myCombo
var toolbar
function initForm() {
    //setContent();
    setTimeout("setContent()", 10);
}

function toDateTimeString(dt) {
    return dt.toLocaleDateString() + " " + dt.toLocaleTimeString().slice(0, 5)
}

function setContent() {
    var rights = top.FireEvent('onCalEventRights');
    if (rights.indexOf("w") != -1) {
        toolbar = new dhtmlXToolbarObject('toolbarObj')
        toolbar.attachEvent("onClick", ToolbarClicked);
        toolbar.setIconsPath("/imgs/");
        toolbar.addButton('btnSave', null, tmxlang["_btn_save"], 'save.png')
        toolbar.addSeparator('sep1', null)
        toolbar.addButton('btnCancel', null, tmxlang["_btn_cancel"], 'cancel.gif')
        toolbar.addSeparator('sep2', null)
        toolbar.addText('text', null, '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;')
        toolbar.addButton('btnDelete', null, tmxlang["_delete"], 'purge.gif')
    }
    // init the tabbar
    tabbar = new dhtmlXTabBar('theTabbar', 'top')

    tabbar.setSkin('dhx_skyblue');
    tabbar.setImagePath("/imgs/");
    tabbar.addTab("a1", tmxlang["_general"], "100px");
    tabbar.addTab("a3", tmxlang['_attendees'], "100px");
    tabbar.addTab("a4", tmxlang['_recurrence'], "100px");
    tabbar.addTab("a5", tmxlang['_alert'], "100px");
    tabbar.addTab("a2", tmxlang['_notes'], "100px");
    tabbar.setContent("a1", "generalTab");
    tabbar.setContent("a2", "notesTab");
    tabbar.setContent("a3", "attendeesTab");
    tabbar.setContent("a4", "recurTab");
    tabbar.setContent("a5", "alertsTab");
    tabbar.setTabActive("a1");
    //tabbar.hideTab("a5")

    // init attendee grid
    attendeeGrid = new dhtmlXGridObject('attendeesTab')
    attendeeGrid.setSkin('dhx_skyblue');
    attendeeGrid.setImagePath("/imgs/");
    attendeeGrid.setHeader('<button class="purgeButton" onclick="deleteAttendee();return false;",' + tmxlang['_email'] + ', ')
    attendeeGrid.setInitWidths("40,400,*"); //set column width in px
    attendeeGrid.setColAlign("left,left,left"); //set column values align
    attendeeGrid.setColTypes("ro,ro,ro"); //set column types
    attendeeGrid.setColSorting("na,str,na"); //set sorting
    attendeeGrid.enableAutoHeight(true);
    attendeeGrid.attachHeader(' ,<div id="attendAddr"></div>,<button valign="top" class="addButton" onclick="addAttendee();return false;" title="' + tmxlang["_btn_add"] + '"></button>&nbsp;&nbsp;, , , ,')
    attendeeGrid.init()
    attendeeGrid.enableMultiselect(true)
    myCombo = new dhtmlXCombo("attendAddr", "x", 380);
    myCombo.enableFilteringMode("between", "/v7/axml/checkcontacts.fts");
    myCombo.attachEvent("onChange", addAttendee);




    var messageObject = {
        parent: "message_body",
        content: ""
    };
    editor2 = new dhtmlXEditor(messageObject);
    editor2.init()

    document.getElementById('until').hidden = true
    document.getElementById('count').hidden = true

    var now = new Date
    now.setSeconds(0);
    now.setMilliseconds(0);
    myCalendar = new dhtmlXCalendarObject('dtstart');
    myCalendar.attachEvent("onClick", CalendarChanged);
    myCalendar.attachEvent("onChange", CalendarChanged);
    myCalendar.setPosition(200, 50)
    myCalendar.setDate(now)
    //myCalendar.hideTime()
    myCalendar2 = new dhtmlXCalendarObject("dtend");
    myCalendar2.setPosition(200, 50)
    myCalendar2.attachEvent("onClick", CalendarChanged2);
    myCalendar2.attachEvent("onChange", CalendarChanged2);
    myCalendar2.setDate(now)
    //myCalendar2.hideTime()


    myCalendar3 = new dhtmlXCalendarObject("until");
    myCalendar3.setPosition(200, 50)
    myCalendar3.attachEvent("onChange", CalendarChanged3);
    myCalendar3.hideTime()


    // also input in a form have ".calendar" css postfix

    var el = document.getElementById('dtstart')
    el.value = toDateTimeString(now)
    el.style.backgroundImage = "url(/dhtmlx/imgs/calendar.gif)";
    el.style.backgroundPosition = "center left";
    el.style.backgroundRepeat = "no-repeat";
    el.style.border = "none";
    el.style.paddingLeft = "20px";
    el.style.readOnly = true;



    el = document.getElementById('dtend')
    el.value = toDateTimeString(now)
    el.style.backgroundImage = "url(/dhtmlx/imgs/calendar.gif)";
    el.style.backgroundPosition = "center left";
    el.style.backgroundRepeat = "no-repeat";
    el.style.border = "none";
    el.style.paddingLeft = "20px";
    el.readOnly = true;

    el = document.getElementById('until')
    el.value = toDateTimeString(now)
    el.style.backgroundImage = "url(/dhtmlx/imgs/calendar.gif)";
    el.style.backgroundPosition = "center left";
    el.style.backgroundRepeat = "no-repeat";
    el.style.border = "none";
    el.style.paddingLeft = "20px";
    el.readOnly = true;


    var data = top.FireEvent('onCalEditorLoaded')
    if (data)
        initFromEvent(data)

    setValue('interval', 1)
    setValue('count', 1)
    setValue('priority', 1)

    updateRecurrence()
}

var attendeeId = 1;
function addAttendee() {
    var addr = myCombo.getComboText()
    addr = addr.replace(",", "&comma;")
    if (utility.isAddress(addr))
        addr = "[" + addr + "]"
    if (addr && addr.length > 0)
        attendeeGrid.addRow(attendeeId++, ',' + addr)
    // delete the old combo and add a new one
    myCombo.destructor()
    myCombo = new dhtmlXCombo("attendAddr", "x", 380);
    myCombo.enableFilteringMode("between", "/v7/axml/checkcontacts.fts");
    myCombo.attachEvent("onChange", addAttendee);
}

function deleteAttendee() {
    attendeeGrid.deleteSelectedRows()
    attendeeGrid.clearSelection()
}


function ToolbarClicked(id) {
    if (id == "btnSave")
        DoSave()
    if (id == "btnCancel")
        top.CloseDialog()
    if (id == "btnDelete") {
        // have to call top to get the schedular to refresh
        top.FireEvent("onCalEventDelete", uid)
        top.CloseDialog()
    }
}


function CalendarChanged(dt) {
    dtstart = dt
    var el = document.getElementById('dtstart')
    if (allday)
        el.value = dtstart.toLocaleDateString()
    else
        el.value = toDateTimeString(dtstart);
    if (!dtend || dtend < dtstart) {
        dtend = dtstart
    }
    CalendarChanged2(dtend)
    myCalendar2.setSensitiveRange(dtstart.getFullYear() + '-' + (dtstart.getMonth() + 1) + "-" + dtstart.getDate(), null)
}

function CalendarChanged2(dt) {
    if (dt)
        dtend = dt
    var el = document.getElementById('dtend')
    if (allday)
        el.value = dtend.toLocaleDateString()
    else
        el.value = toDateTimeString(dtend);
}

function CalendarChanged3(dt) {
    var el = document.getElementById('until')
    el.value = toDateTimeString(dt)
}


function updateRecurrence() {
    if (currentFreq == "none") {
        // use the current date to set the day and month flags
        var day = dtstart.getDate();
        document.getElementById("bymonthday_" + day).checked = true;
        var month = dtstart.getMonth() + 1;
        document.getElementById("bymonth_" + month).checked = true;
        var dow = dtstart.getDay();
        if (dow == 0) dow = 7
        document.getElementById("byday" + dow + "a").checked = true;

    }

    var el = document.getElementById('freq');
    var freq = el.value
    document.getElementById('section_interval').hidden = true
    document.getElementById('section_byday').hidden = true
    document.getElementById('section_byweekday').hidden = true
    document.getElementById('section_bymonthday').hidden = true
    document.getElementById('section_bymonth').hidden = true
    document.getElementById('section_rec_end').hidden = true
    document.getElementById('section_lbldays').style.display = "none"
    document.getElementById('section_lblweeks').style.display = "none"
    document.getElementById('section_lblmonths').style.display = "none"
    document.getElementById('section_lblyears').style.display = "none"
    if (freq == "DAILY1") {
        document.getElementById('section_byday').hidden = false
        document.getElementById('section_rec_end').hidden = false
    }
    if (freq == "DAILY") {
        document.getElementById('section_interval').hidden = false
        document.getElementById('section_rec_end').hidden = false
        document.getElementById('section_lbldays').style.display = "inline"
    }
    if (freq == "WEEKLY") {
        document.getElementById('section_interval').hidden = false
        document.getElementById('section_lblweeks').style.display = "inline"
        document.getElementById('section_byday').hidden = false
        document.getElementById('section_rec_end').hidden = false
    }
    if (freq == "MONTHLY1") {
        document.getElementById('section_interval').hidden = false
        document.getElementById('section_lblmonths').style.display = "inline"
        document.getElementById('section_bymonthday').hidden = false
        document.getElementById('section_rec_end').hidden = false
    }
    if (freq == "MONTHLY2") {
        //document.getElementById('section_interval').hidden=false
        document.getElementById('section_lblmonths').style.display = "inline"
        document.getElementById('section_byweekday').hidden = false
        document.getElementById('section_bymonth').hidden = false
        document.getElementById('section_rec_end').hidden = false
    }
    if (freq == "YEARLY") {
        document.getElementById('section_interval').hidden = false
        document.getElementById('section_lblyears').style.display = "inline"
        document.getElementById('section_bymonthday').hidden = false
        document.getElementById('section_bymonth').hidden = false
        document.getElementById('section_rec_end').hidden = false
    }
    if (freq == "YEARLY2") {
        document.getElementById('section_interval').hidden = false
        document.getElementById('section_lblyears').style.display = "inline"
        document.getElementById('section_byweekday').hidden = false
        document.getElementById('section_bymonth').hidden = false
        document.getElementById('section_rec_end').hidden = false
    }
    el = document.getElementById('rec_endtype');
    var val = el.value
    document.getElementById('until').hidden = val != 1
    document.getElementById('count').hidden = val != 2

    el = document.getElementById('allday');
    if (allday != el.checked) {
        allday = el.checked
        UpdateAllDay();
    }
    currentFreq = freq;

    /*
    el = document.getElementById('noend');
    if (noend != el.checked) {
    UpdateNoEndDay();
    }
    */
}

function fieldChanged(id) {
    updateRecurrence();
}

function UpdateNoEndDay() {
    var el = document.getElementById('noend');
    noend = el.checked
    document.getElementById('section_dtend').hidden = noend
}

function UpdateAllDay() {
    if (allday) {
        dtstart.setMinutes(0);
        dtstart.setHours(0);
        myCalendar.setDate(dtstart)
        myCalendar.hideTime()
        dtend.setMinutes(0);
        dtend.setHours(0);
        myCalendar2.setDate(dtend)
        myCalendar2.hideTime()
    }
    else {
        myCalendar.showTime()
        myCalendar2.showTime()
    }
    CalendarChanged(dtstart)
}

function addLabel(label) {
    document.write('<div style="display:inline-block;width:200px;font-weight: bold;color: #256187;margin-left:3px">' + label + '</div>')
}
function addFormLabel2(label, id) {
    document.write('<div id="section_' + id + '"style="display:inline;font-weight: bold;color: #256187;margin-left:3px">' + label + '</div>')
}
function startBlock(id) {
    document.write('<div id="section_' + id + '" style="margin-top:5px;width:600px">')
}

function endBlock() {
    document.write('</div>')
}

function addFormInput(label, id, size) {
    if (size == undefined)
        size = "350"
    startBlock(id)
    addLabel(label)
    document.write('<input type="text" style="width:' + size + 'px" id="' + id + '" value="">');
    document.write("<br/>")
    endBlock()
}
function addFormInput2(label, id, size) {
    if (size == undefined)
        size = "200"
    document.write('<input type="text" style="width:' + size + 'px" id="' + id + '" value="">' + label);
}

function addFormBool(label, id) {
    startBlock(id)
    addLabel(label)
    document.write('<input type="checkbox" size="40" id="' + id + '" value="" onclick="fieldChanged(\'' + id + '\')">');
    document.write("<br/>")
    endBlock()
}
function addFormBool2(label, id, size) {
    if (size != undefined)
        size = "width:" + size + "px";
    else
        size = ""
    document.write('<div style="float:left;' + size + '"><input type="checkbox" size="40" id="' + id + '" onclick="fieldChanged(\'' + id + '\')" value="">&nbsp;' + label + '</div>');
}

function addFormOptions(label, id, options) {
    startBlock(id)
    addLabel(label)
    document.write('<select onchange="fieldChanged(\'' + id + '\')" id="' + id + '">')
    for (var i = 0; i < options.length; i++)
        document.write('<option value="' + options[i][0] + '">' + options[i][1] + '</option>')
    document.write('</select>');
    document.write("<br/>")
    endBlock()
}

function addFormOptions2(label, id, options) {
    document.write('<select id="' + id + '">')
    for (var i = 0; i < options.length; i++)
        document.write('<option value="' + options[i][0] + '">' + options[i][1] + '</option>')
    document.write('</select>' + label);
}
function addFormLabel(label, id) {
    startBlock(id)
    addLabel(label);
    endBlock()
}
function addFormTextblock(id) {
    document.write('<textarea style="width:100%;height:360px;border:none" id="' + id + '"></textarea>')
}

function addFormDiv(label, id) {
    //addLabel(label)
    document.write('<div id=' + id + ' style="margin-top:5px;width:590px;height:190px;border:solid 1px black"></div>');
}

function startParamList() {
    document.write('<div style="width:400px;margin-left:200px">')
}

function endParamList() {
    document.write('<div style="clear:both"></div></div>')
}

function startTab(id, name) {
    document.write('<div id="' + id + '" name="' + name + '">')
}
function endTab() {
    document.write("</div>")
}
function formatlang(str, field, val) {
    return str.replace(field, val);
}
//<div id="theTabbar" c1lass="dhtmlxTabBar" imgpath="/imgs/" style="width: 100%; height: 100%;">
