﻿var STORE_DB_MAILBOX_USER=7
var STORE_DB_MAILBOX_LIST=8
var STORE_DB_MAILBOX_GROUP=11
var STORE_DB_MAILBOX_NULL=12
var STORE_DB_MAILBOX_DSN=13
var STORE_DB_MAILBOX_DOMAIN=14
var STORE_DB_MAILBOX_DAEMON=15
var STORE_DB_MAILBOX_ALIAS=16

function IgnoreError() { }
window.dhtmlxError.catchError("Incorrect XML", IgnoreError);

var dataStore = {};// top.dataStore

var accountView = {
type:0,
    address: "",
    account: "",
    tabbar: null,
    dhxLayout: null,
    mailLayout: null,
    projectsLayout: null,
    optionsLayout: null,
    trackingLayout: null,
    directory: [],
    tabIndex: 1,
    localCache: [],
    preferences: {},
    isLoggedInAccount: false,
    percentageFull:0,
    SetPreference: function (id, value) {
        accountView.preferences[id] = value
        if (accountView.isLoggedInAccount) {
            // save changes
            var prefs=JSON.stringify(accountView.preferences)
            dhtmlxAjax.get('/v7/axml/setprefs.fts?mailbox=' + accountView.account + '&type=prefs&val=' + prefs, function (loader) { ; });
        }
    },
    GetPreference: function (id) {
        return accountView.preferences[id]
    }
}

accountView.addTab = function (name, url, size) {
    var id = "a" + accountView.tabIndex;
    accountView.tabbar.addTab(id, name, size || "100px");
    accountView.tabbar.setContentHref(id, url);
    accountView.tabIndex++
}

function initPage(address, account, mailboxType) {

    if (typeof (localStorage) != undefined)
        if (top.isembedded || localStorage["remember"] == "true")
            dataStore = localStorage
    
    dhtmlx.image_path = '/imgs/';
    accountView.type = mailboxType;
    accountView.account = account;
    accountView.address = address;
    accountView.isLoggedInAccount = address == top.thisMailbox
    var pr= dataStore["directory"]
    if (pr == undefined || !accountView.isLoggedInAccount)
        accountView.RefreshDirectory()
    else {
        accountView.directory = JSON.parse(pr);
        accountView.DirectoryUpdated();
    }
}

accountView.Put = function (key, value) {
    var v = JSON.stringify(value)
    dataStore[key] = v;
}

accountView.Get = function (key) {
    var retVal
    try {
        var v = dataStore[key]
        retVal = JSON.parse(v);
    }
    catch (e) {
    }
    return retVal;
}

accountView.RefreshDirectory = function (extra) {
    top.SetStatus("Refreshing...")
    if (extra == undefined)
        extra = ""
    dhtmlxAjax.get("/v7/json/directory.fts?mailbox=" + accountView.account + extra, accountView.DirectoryCallback);
}

accountView.DirectoryCallback = function (loader) {
    var s = loader.xmlDoc.responseText
    accountView.directory = JSON.parse(s);
    if (accountView.isLoggedInAccount)
        dataStore["directory"] = s
    accountView.DirectoryUpdated()
    top.SetStatus("")
}

accountView.DirectoryUpdated = function () {
    accountView.FixAccessRights()
    if (!accountView.dhxLayout) {
        accountView.ShowView();
    }
    // tell everyone that there was an update
    mailView.DirectoryUpdated();
    projectsView.DirectoryUpdated();
    optionsView.DirectoryUpdated();
    trackingView.DirectoryUpdated();
}

accountView.FixAccessRights = function () {
    // go though the directory and if we find a project folder
    // set the rights to read, unless its managed , in whihc case its full.
    // if its a project folder rights are r/w
    // we also set the account compose options
    for (var i = 0; i < accountView.directory.length; i++) {
        var rights = ""
        accountView.directory[i].compose = true;
        if (accountView.directory[i].type == 11) {
            rights = "r"
            accountView.directory[i].compose = false;
            if (accountView.directory[i].extendedmode0 == "project")
                rights = "r"
            if (accountView.directory[i].userdata == "manager" ||
                accountView.directory[i].extendedmode1 == "full") {
                accountView.directory[i].compose = true;
                rights = "rwdm"
            }
        }
        if (accountView.directory[i].type == 14) {
            rights = "rwmd"
            accountView.directory[i].compose = false;
        }
        if (rights != "") {
            for (var j = 0; j < accountView.directory[i].items.length; j++) {
                var item = accountView.directory[i].items[j]
                if (item.type == 116 && item.path.indexOf("~") == -1 && item.path.indexOf("/Shared/") == -1)
                    if (accountView.directory[i].items[j].rights != "")
                        accountView.directory[i].items[j].rights = rights;
            }
        }
    }
}

accountView.ShowView = function () {
    dhtmlx.image_path = '/imgs/';
    accountView.dhxLayout = new dhtmlXLayoutObject(document.body, '1C');
    accountView.tabbar = accountView.dhxLayout.cells("a").attachTabbar();
    accountView.tabbar.setSkin('dhx_skyblue');
    accountView.tabbar.setImagePath("/imgs/");
    accountView.tabbar.enableAutoReSize(true);
    //accountView.tabbar.setHrefMode("iframe");
    accountView.tabbar.attachEvent("onTabClick", accountView.OnTabClick);
    switch (accountView.directory[0].type) {
        case STORE_DB_MAILBOX_DOMAIN:
            accountView.tabbar.addTab('tab_mail', tmxlang["_mail"], "100px");
            accountView.mailLayout = accountView.tabbar.cells('tab_mail').attachLayout("2U");
            mailView.Init(accountView.mailLayout);
            accountView.tabbar.setTabActive('tab_mail')
            break;
        case STORE_DB_MAILBOX_USER:
        case STORE_DB_MAILBOX_GROUP:
            accountView.tabbar.addTab('tab_mail', tmxlang["_mail"], "100px");
            accountView.mailLayout = accountView.tabbar.cells('tab_mail').attachLayout("2U");
            if (top.edition == 0)
                accountView.tabbar.addTab('tab_projects', tmxlang["_projects"], "100px");
            else
                accountView.tabbar.addTab('tab_projects', tmxlang["_addresses"], "100px");
            accountView.projectsLayout = accountView.tabbar.cells('tab_projects').attachLayout("2U");
            accountView.tabbar.addTab('tab_options', tmxlang["_options"], "100px");
            accountView.optionsLayout = accountView.tabbar.cells('tab_options').attachLayout("2U");
            accountView.tabbar.addTab('tab_tracking', tmxlang["_tracking"], "100px");
            accountView.trackingLayout = accountView.tabbar.cells('tab_tracking').attachLayout("2U");
            // now init the modules
            mailView.Init(accountView.mailLayout);
            projectsView.Init(accountView.projectsLayout)
            optionsView.Init(accountView.optionsLayout)
            trackingView.Init(accountView.trackingLayout)
            accountView.tabbar.setTabActive('tab_mail')
            break;
        case STORE_DB_MAILBOX_LIST:
            accountView.tabbar.addTab('tab_mail', tmxlang["_mail"], "100px");
            accountView.mailLayout = accountView.tabbar.cells('tab_mail').attachLayout("2U");
            accountView.tabbar.addTab('tab_projects', tmxlang["_addresses"], "100px");
            accountView.projectsLayout = accountView.tabbar.cells('tab_projects').attachLayout("2U");
            accountView.tabbar.addTab('tab_options', tmxlang["_options"], "100px");
            accountView.optionsLayout = accountView.tabbar.cells('tab_options').attachLayout("2U");
            mailView.Init(accountView.mailLayout);
            projectsView.Init(accountView.projectsLayout)
            optionsView.Init(accountView.optionsLayout)
            //trackingView.Init(accountView.trackingLayout)
            accountView.tabbar.setTabActive('tab_mail')
            break;
        default:
            break;
    }
}

accountView.OnTabClick = function (id, last_id) {
    if (last_id == "tab_projects") {
        // tell projects were closing
        projectsView.TabClosing();
    }
    if (id == "tab_projects") {
        // tell projects were closing
        setTimeout('projectsView.TabOpening()',100)
    }
    return true;
}

accountView.ItemFromId = function (id) {
    for (i=0;i<accountView.directory.length;i++)
    {
        var project=accountView.directory[i];
        for (j=0;j<project.items.length;j++)
            if (project.items[j].id==id)
                return project.items[j]
    }
}