

var projectsView = {
    accordion: null,
    content: null,
    selectedProjectItem: null,
    selectedCell:null,
    currentMailbox: null,
    currentFolder: null,
    currentProjectItem:"",
    main_layout: null,
    readingPane: null,
    grid: null,
    toolbar: null,
    treePane: null,
    itemType: 5,
    rightPane: null,
    currentRights: "",
    acceptDropFiles: false,
    folderIcon: [],
    canEdit : true,
    newOptions: [],
    selectedGrid:null,
    currentView:null
}


projectsView.Init = function (layout) {
    currentMailbox = accountView.account;

    projectsView.main_layout = layout
    projectsView.main_layout.setAutoSize("b", "b")

    projectsView.treePane = projectsView.main_layout.cells('a');
    projectsView.treePane.setWidth('300');

    projectsView.leftToolbar = projectsView.treePane.attachToolbar();
    projectsView.treePane.showHeader();

    projectsView.folderIcon[46] = "/imgs/contact.gif"
    projectsView.folderIcon[47] = "/imgs/contact.gif"
    projectsView.folderIcon[109] = '/imgs/cal.gif'
    projectsView.folderIcon[110] = '/imgs/task.gif'
    projectsView.folderIcon[119] = '/imgs/notes.gif'
    projectsView.folderIcon[132] = '/imgs/folderclosed.gif'
    projectsView.folderIcon[134] = '/imgs/64-zap.png'


    if (top.edition == 0) { //EDITION_PRO
        projectsView.leftToolbar.addButton("refresh", 0, '', '/images/recur.gif')
        projectsView.leftToolbar.setItemToolTip("refresh", tmxlang["_refresh"])
        projectsView.leftToolbar.addSeparator('s1', 0);
        projectsView.leftToolbar.addButton("options", 0, '', '/images/v7/20-gear2.png')
        projectsView.leftToolbar.setItemToolTip("options", tmxlang["_options"])
            projectsView.leftToolbar.addButton("share", 0, "", '/images/group.png')
            projectsView.leftToolbar.setItemToolTip("share", tmxlang["_share"])
        projectsView.leftToolbar.addSeparator('s1', 0);
        projectsView.leftToolbar.addButton("del", 0, '', '/imgs/folderdelete.png')
        projectsView.leftToolbar.setItemToolTip("del", tmxlang["_btn_delete"])
        projectsView.leftToolbar.setAlign('right')
        if (top.edition == 0)  //EDITION_PRO
            projectsView.leftToolbar.disableItem("share");

        projectsView.newOptions = [['new_contact', 'obj', tmxlang["_addressbook"], '/imgs/contact.gif'],
                           ['new_calendar', 'obj', tmxlang["_calendar"], '/imgs/cal.gif'],
                           ['new_tasks', 'obj', tmxlang["_tasks"], '/imgs/task.gif'],
                           ['new_journal', 'obj', tmxlang["_nav_journal"], '/imgs/notes.gif'],
                           ['new_document', 'obj', tmxlang["_nav_documents"], '/imgs/folderclosed.gif'],
                           ['new_issue', 'obj', tmxlang["_nav_issue"], '/imgs/64-zap.png']]
        projectsView.leftToolbar.addButtonSelect("add", 0, tmxlang["_btn_add"], projectsView.newOptions, '/imgs/folderadd.png', '/imgs/folderadd.png');
        projectsView.leftToolbar.setItemToolTip("add", tmxlang["_btn_add"])
        projectsView.leftToolbar.addSeparator('s1', 0);


        projectsView.leftToolbar.attachEvent("onclick", projectsView.OnLeftToolbar);
    }

    var a = projectsView.main_layout.cells('a');
    a.hideHeader()
    var b = projectsView.main_layout.cells('b');
    projectsView.rightPane = b.attachLayout('1C');
    journal.Init()
    tasks.Init()
    issues.Init()
}

projectsView.GetCN = function (address) {
    for (var i = 0; i < accountView.directory.length; i++) {
        if (accountView.directory[i].account == address)
            return accountView.directory[i].cn;
    }
    return address;
}

projectsView.DirectoryUpdated = function () {
    projectsView.accordion = projectsView.main_layout.cells('a').attachAccordion()
    projectsView.accordion.attachEvent("onActive", projectsView.SelectProject);
    var selectedProject = accountView.GetPreference("project_selected") || "account0"
    var selectedItem = accountView.GetPreference("project_item") || 0
    var selectedCell;
    var theItem = 0;
    var toggles = []
    var addresses = ":"
    var directory = accountView.directory
    for (var i = 0; i < directory.length; i++) {
        if (addresses.indexOf(":" + directory[i].account + ":") != -1)
            continue;
        if (directory[i].type == 11 && directory[i].extendedmode0 != "project" && directory[i].userdata != "manager" && accountView.address != directory[i].account)
            continue;

        addresses += ":" + directory[i].account + ":";
        directory[i].author = directory[i].account // the author is used when creating new entries
        var prefix = '/imgs/projects/user.png'
        if (directory[i].extendedmode0.indexOf("project") != -1) {
            prefix = '/imgs/projects/project.png'
            directory[i].author = directory[i].ref
        }
        if (directory[i].userdata.indexOf("manager") != -1 && directory[i].type == 11) {
            prefix = '/imgs/projects/manager.png'//tmxlang["_manager"];
            directory[i].author = directory[i].ref
        }
        var text = directory[i].cn
        var name = "account" + i;


        directory[i].ref = name
        var cell = projectsView.accordion.addItem(name, text);
        cell.setIcon(prefix)
        directory[i].accordionCell = cell;
        projectsView.accordion.openItem(name)
        var grid = cell.attachGrid()
        grid.setHeader("icon," + name)
        grid.setInitWidths("25,*")
        grid.setSkin("dhx_skyblue");
        grid.setImagePath("/imgs/");

        grid.setColTypes("img,ro")
        grid.setNoHeader(true);
        grid.init()

        grid.attachEvent("onRowSelect", projectsView.OnProjectSelect);
        directory[i].grid = grid;
        directory[i].visible = true
        for (j = 0; j < directory[i].items.length; j++) {
            var projItem = directory[i].items[j]
            if (top.edition != 0 && projItem.type != 46 && projItem.type != 47 && projItem.type != 48 && projItem.type != 116)  //EDITION_PRO
                continue; // only show address books
            var pathParts = projItem.path.split('/');
            if (pathParts[2] == "Folder" || pathParts[2] == "root")
                continue; // dont do folders
            if (projItem.ownertype == 11 && directory[i].type == 7)
                continue; // this is a group item in a normal mailbox 
            if (projItem.ownertype == 8 && directory[i].type == 7)
                continue; // this is a list item in a normal mailbox 
            if (projItem.type == 0 || pathParts.length <= 3)
                continue
            // now do what we need to do
            var projectName = projItem.name
            if (projItem.path.indexOf("/shared/") != -1) {
                if (directory[i].account.indexOf(pathParts[4]) != -1)
                    projectName += " [" + pathParts[5] + "]"
                else
                    projectName += " [" + pathParts[5] + "/" + pathParts[4] + "]";
            }
            rid = i + "_" + j
            grid.addRow(rid, projectsView.folderIcon[projItem.type] + "," + projectName);
            if ((selectedProject == name && selectedItem == j) || theItem == 0)
                theItem = rid
        }
        //grid.sortRows(1,"str","asc") // crashes ie11
        if (selectedProject == name) {
            projectsView.selectedGrid = grid
            selectedCell = cell;
        }
    }
    // hide any non visible items

    var vis = "" + accountView.GetPreference("hiddendirectory")
    for (i = 0; i < directory.length; i++) {
        var text = directory[i].cn
        var t = ['toggle_' + i, 'obj', text, '/images/v7/72-pin.png']
        if (vis.indexOf(directory[i].userdata + "_" + directory[i].account) != -1) {
            if (directory[i].accordionCell) {
                directory[i].accordionCell.hide()
                directory[i].visible = false;
                t[3]=''
            }
        }
         toggles.push(t)
     }

    // add the show hide options
    // show hide option
    if (top.edition == 0) { //EDITION_PRO
        projectsView.leftToolbar.removeItem("show");
        projectsView.leftToolbar.addButtonSelect("show", 0, tmxlang["_btn_show"], toggles, '/images/04-eye.png', '/images/04-eye.png');
        projectsView.leftToolbar.setItemToolTip("show", tmxlang["_visibility"])
    }


    if (selectedCell)
        selectedCell.open()
    try {
        if (theItem)
            projectsView.selectedGrid.selectRowById(theItem, true);
        else
            projectsView.selectedGrid.selectRow(0, true);
    }
    catch (e) { }

    projectsView.OnProjectSelect(theItem)
}

projectsView.SelectProject=function(itemId, state) {
    accountView.SetPreference("project_selected",itemId)

    for (i = 0; i < accountView.directory.length; i++) {
        if (accountView.directory[i].ref == itemId) {
            projectsView.currentMailbox = accountView.directory[i].uid
            var isLocked = accountView.directory[i].userdata == "group"
            var isshared = false;
            var canshare = false
            var canadd = !isLocked
            var candel = !isshared && !isLocked
            projectsView.EnableToolbarOptions(candel && projectsView.canEdit, canadd && projectsView.canEdit, canshare && !isshared, false);
        }
    }
}

projectsView.TabClosing=function()
{
    if (projectsView.currentView != undefined)
        projectsView.currentView.Hide();
}

projectsView.TabOpening = function () {
    if (projectsView.currentProjectItem!="")
        projectsView.OnProjectSelect(projectsView.currentProjectItem)
}

projectsView.OnProjectSelect = function (rid) {
    if (rid == undefined)
        return;
    projectsView.currentProjectItem = rid
    var directory = accountView.directory
    projectsView.main_layout.cells('b').view("def").setActive()

    if (projectsView.currentView != undefined)
        projectsView.currentView.Hide();

    var view
    var k = rid.split("_");
    var project = parseInt(k[0])
    var item = parseInt(k[1])
    var projItem = directory[project].items[item]
    projectsView.selectedProjectItem = projItem
    accountView.SetPreference("project_item",item);
    projectsView.currentFolder = projItem.id;
    projectsView.currentMailbox = directory[project].uid;
    if (projectsView.selectedGrid && projectsView.selectedGrid != directory[project].grid) {
        projectsView.selectedGrid.clearSelection();
        projectsView.selectedGrid = directory[project].grid
    }
    // configur the toolbar
    var isLocked = directory[project].userdata == "group"
    var isshared = projItem.path.indexOf("shared") != -1
    var isinbox = projItem.path.indexOf("//folder/inbox") != -1
    var canshare = (projItem.rights.indexOf("m") != -1) && !isLocked
    var canadd = !isLocked
    var canren = (projItem.rights.indexOf("m") != -1) && !isLocked
    var candel = !isinbox && !isshared && !isLocked

    if (projItem.type == 47) {
        canren = false;
        candel = false;
    }

    // load the correct page

    switch (projItem.type) {
        case 46: // contacts
        case 47: // contacts
            view = contacts
            isLocked = true;
            break;
        case 109: // calendars
            view = calendar
            break;
        case 110: // tasks
            view = tasks
            break;
        case 134: // issues
            view = issues
            break;
        case 119: // journal
            view = journal
            break;
        case 132: // documents
            view = documents
            isLocked = true;
            break;
    }

    projectsView.EnableToolbarOptions(candel && projectsView.canEdit, canadd && projectsView.canEdit, canshare && !isshared, false, !isLocked);


    projectsView.currentView = view
    if (projectsView.currentView) {
        projectsView.currentRights = projItem.rights
        projectsView.currentView.Show(projItem, directory[project]);
        if (directory.length == 1)
            projectsView.main_layout.cells('b').setText(projItem.name)
        else
            projectsView.main_layout.cells('b').setText('<img src="' + projectsView.folderIcon[projItem.type] + '" style="vertical-align: middle;display:inline-block;"> ' + projItem.name + " [" + directory[k[0]].cn + "]")
        projectsView.main_layout.cells('b').showHeader()
    }
}


projectsView.EnableToolbarOptions = function (del, add, share, fav, opts) {
    if (top.edition != 0)  //EDITION_PRO
        return;
    rename = false;

    if (del)
        projectsView.leftToolbar.enableItem("del")
    else
        projectsView.leftToolbar.disableItem("del")


    if (share)
        projectsView.leftToolbar.enableItem('share')
    else
        projectsView.leftToolbar.disableItem('share')

    if (add)
        projectsView.leftToolbar.enableItem('add')
    else
        projectsView.leftToolbar.disableItem('add')

    if (opts)
        projectsView.leftToolbar.enableItem("options")
    else
        projectsView.leftToolbar.disableItem("options")
}

projectsView.OnLeftToolbar=function(id) {
    if (id == "refresh")
        accountView.RefreshDirectory();
    if (id == "share") {
        // open the share window
        top.OpenDialog(700, 400, tmxlang["_share"], '/v7/utility/share.fts?id=' + projectsView.currentFolder, projectsView.RefreshFolders);
    }
    if (id == "options") {
        // open the share window
        top.OpenDialog(800, 600, tmxlang["_options"], '/v7/webmail/options/folder.fts?id=' + projectsView.currentFolder, projectsView.RefreshFolders);
    }
    if (id == "del") {
        // need to confirm the delete
        var r = confirm(tmxlang["_confirm_delete"] + "\n" + projectsView.selectedProjectItem.name);
        if (r == true) {
            accountView.RefreshDirectory('&delete=' + projectsView.currentFolder)
        }
    }
    if (id == "new_calendar") {
        var newPath = prompt("New Calendar", "");
        if (newPath != null && newPath != "")
            accountView.RefreshDirectory('&parent=' + projectsView.currentMailbox + '&type=calendar&create=' + newPath)
    }
    if (id == "new_tasks") {
        var newPath = prompt("New Task List", "");
        if (newPath != null && newPath != "")
            accountView.RefreshDirectory('&parent=' + projectsView.currentMailbox + '&type=tasklist&create=' + newPath)
    }
    if (id == "new_journal") {
        var newPath = prompt("New Journal", "");
        if (newPath != null && newPath != "")
            accountView.RefreshDirectory('&parent=' + projectsView.currentMailbox + '&type=journal&create=' + newPath)
    }
    if (id == "new_contact") {
        var newPath = prompt("New Address Book", "");
        if (newPath != null && newPath != "")
            accountView.RefreshDirectory('&parent=' + projectsView.currentMailbox + '&type=addresses&create=' + newPath)
    }
    if (id == "new_document") {
        var newPath = prompt("New Document Folder", "");
        if (newPath != null && newPath != "")
            accountView.RefreshDirectory('&parent=' + projectsView.currentMailbox + '&type=document&create=' + newPath)
    }
    if (id == "new_issue") {
        var newPath = prompt("New Issue List", "");
        if (newPath != null && newPath != "")
            accountView.RefreshDirectory('&parent=' + projectsView.currentMailbox + '&type=issue&create=' + newPath)
    }
    if (id.indexOf("toggle") != -1) {
        var k = id.split("_");
        var id2 = "account" + k[1]
        var toggles=[]
        project=accountView.directory[parseInt(k[1])]
        if (project.visible) {
            projectsView.accordion.cells(id2).hide()
            project.visible = false;
        }
        else {
            projectsView.accordion.cells(id2).show()
            projectsView.accordion.cells(id2).open()
            project.visible = true;
        }
        // store visible list
        var vis = "";
        for (i = 0; i < accountView.directory.length; i++) {
            if (!accountView.directory[i].visible)
                vis += accountView.directory[i].userdata+"_"+accountView.directory[i].account + ";"
        }
        var directory = accountView.directory
        accountView.SetPreference("hiddendirectory", vis)
        for (i = 0; i < directory.length; i++) {
            var text = directory[i].cn
            var t = ['toggle_' + i, 'obj', text, '/images/v7/72-pin.png']
            if (vis.indexOf(directory[i].userdata + "_" + directory[i].account) != -1) {
                if (directory[i].accordionCell) {
                    t[3] = ''
                }
            }
            toggles.push(t)
        }
        // add the show hide options
        // show hide option
        if (top.edition == 0) { //EDITION_PRO
            projectsView.leftToolbar.removeItem("show");
            projectsView.leftToolbar.addButtonSelect("show", 0, tmxlang["_btn_show"], toggles, '/images/04-eye.png', '/images/04-eye.png');
            projectsView.leftToolbar.setItemToolTip("show", tmxlang["_visibility"])
        }

    }
}