// contact functions

var contacts = {
    isListView: false,
    extraData: "",
    gridView: null,
    dataView: null,
    toolbar: null,
    data: [],
    currentType: 0,
    wantInit: true,
    projectItem: {},
    project:{}
}

contacts.Hide=function() {
    projectsView.main_layout.cells('b').view("def").setActive()
}

contacts.Init = function () {
    if (localStorage["contacts.isListView"] == undefined)
        localStorage["contacts.isListView"] = "false";
    contacts.isListView = localStorage["contacts.isListView"] == "true";
    contacts.wantInit = false;
    rightPane = projectsView.main_layout.cells('b').view("contacts").attachLayout('1C');
    var buttonIndex = 0;
    contacts.toolbar = rightPane.attachToolbar()
    contacts.toolbar.addButton("add", null, tmxlang["_btn_add"], '/images/add.gif', '/images/add.gif')
    contacts.toolbar.addButton("del", null, tmxlang["_btn_delete"], '/images/buttons/icons/purge.gif', '/images/buttons/icons/purge.gif')
    contacts.toolbar.addSeparator("s1", null)
    contacts.toolbar.addButtonTwoState("card", null, "", "/imgs/v7mail/card.png")
    contacts.toolbar.setItemToolTip("card", tmxlang["_card"]);
    contacts.toolbar.addButtonTwoState("list", null, "", "/imgs/v7mail/list.png")
    contacts.toolbar.setItemToolTip("list", tmxlang["_list"]);
    contacts.toolbar.addSeparator("sx", null)
    contacts.toolbar.addButton("btn_export", null, '', "/imgs/save.png")
    contacts.toolbar.setItemToolTip("btn_export", tmxlang["_btn_export"]);
    contacts.toolbar.addButton("btn_rawexport", null, '', "/imgs/save.png")
    contacts.toolbar.setItemToolTip("btn_rawexport", tmxlang["_btn_export"]);
    contacts.toolbar.addButton("btn_import", null, '', "/imgs/import.png")
    contacts.toolbar.setItemToolTip("btn_import", tmxlang["_btn_import"]);

    contacts.toolbar.addSeparator("s0", null)
    contacts.toolbar.addButton("btn_print", null, tmxlang["_print"], "/imgs/icons/printer.png")
    contacts.toolbar.addSeparator("s1", null)
    contacts.toolbar.addInput("search", null, '', 200);
    contacts.toolbar.attachEvent("onclick", contacts.onButtonChange);
    contacts.toolbar.attachEvent("onstatechange", contacts.onButtonChange);
    contacts.toolbar.attachEvent("onenter", contacts.onValueChange)
    obj = contacts.toolbar.getInput('search')
    obj.onkeyup = function () {
        contacts.onValueChange("search");
    }

    contacts.toolbar.addButton("clear", null, "", '/images/v7/11-x.png', '/images/v7/11-x.png')
    //    var l=tmxlang['_alphabet'];
    //    for (i=0;i<l.length;i++)
    //        addSearchButton(l.slice(i,i+1))

    rightTop = rightPane.cells('a')
    rightTop.hideHeader()
}

contacts.Show = function (item, project) {
    
    contacts.projectItem = item;
    contacts.project=project
    if (contacts.wantInit) {
        contacts.Init();
        contacts.ChangeView();
    }
    projectsView.main_layout.cells('b').view("contacts").setActive()

    // set the display state of the tools
    if (contacts.projectItem.type != 47 || project.userdata == "owner" || project.userdata == "manager") {
        contacts.toolbar.showItem('add')
        contacts.toolbar.showItem('del')
    }
    else {
        // hide
        contacts.toolbar.hideItem('add')
        contacts.toolbar.hideItem('del')
    }

    if (contacts.isListView)
        contacts.gridView.clearAll();
    else
        contacts.dataView.clearAll();

    if (accountView.localCache[contacts.projectItem.id]) {
        contacts.data = JSON.parse(accountView.localCache[contacts.projectItem.id]);
        contacts.UpdateView()
    }
    else
        this.ReloadContactData();

    contacts.showHideTools()
}

contacts.ReloadContactData=function(extraData)
{
    if (extraData==undefined)
        extraData=""
    rightPane.progressOn()
    dhtmlxAjax.get('/v7/json/contacts.fts?type=grid&mailbox=' + contacts.project.uid + "&abid=" + contacts.projectItem.id+extraData, contacts.DataLoaded);
}

contacts.DataLoaded = function (loader) {
    var s = loader.xmlDoc.responseText
    if (s && s != "")
        contacts.data = JSON.parse(s);
    for (i = 0; i < contacts.data.length; i++) {
        var a = contacts.data[i]
        if (a) {
            p = a.postaladdress
            a.postaladdress2 = p.replace(/\r/g, "<br/>")
            a.cn2 = a.cn.replace(/'/g, "&apos;");
            a.givenname = a.givenname.replace(/,/g, "&comma;");
            a.sn = a.sn.replace(/,/g, "&comma;");
            a.o = a.o.replace(/,/g, "&comma;");
        }
    }

    accountView.localCache[contacts.projectItem.id] = s
    contacts.UpdateView()
    rightPane.progressOff()
}

contacts.UpdateView=function()
{
    localStorage["contacts.isListView"]= contacts.isListView ? "true":"false";
    if (contacts.data.length==0)
        return
    if (contacts.isListView)
    {

        // we want to insert the data from the callback
        contacts.gridView.clearAll();
        for (var i=0;i<contacts.data.length;i++)
        {
            contacts.gridView.addRow(contacts.data[i].id,
                " "+
                "," + contacts.data[i].cn.replace(/,/g, "&comma;") +
                "," + contacts.data[i].givenname.replace(/,/g, "&comma;") +
                "," + contacts.data[i].sn.replace(/,/g, "&comma;") +
                "," + contacts.data[i].o.replace(/,/g, "&comma;") +
                "," + contacts.data[i].mail.replace(/,/g, "&comma;") +
                "," + contacts.data[i].telephonenumber.replace(/,/g, "&comma;") +
                ", "
                )
        }
    }
    else
    {

        contacts.dataView.clearAll();
        contacts.dataView.parse(contacts.data,"json");
        contacts.dataView.sort("#cn#","asc")
    }
}

contacts.ChangeView = function () {
    if (contacts.isListView) {
        contacts.toolbar.setItemState("card", false)
        contacts.toolbar.setItemState("list", true)
        contacts.gridView = rightTop.attachGrid("dataGrid")
        contacts.gridView.setHeader(" ," + tmxlang["_name"] + "," + tmxlang["_firstname"] + "," + tmxlang["_lastname"] + "," + tmxlang["_company"] + "," + tmxlang["_mail"] + "," + tmxlang["_phone"])
        contacts.gridView.setInitWidths("5,*,*,*,*,*,*,20")
        contacts.gridView.setColAlign("right,left,left,left,left,left,left,left"); //set column values align
        contacts.gridView.setColTypes("ro,ro,ro,ro,ro,ro,ro,ro"); //set column types
        contacts.gridView.setColSorting("na,str,str,str,str,str,str,str"); //set sorting
        contacts.gridView.attachHeader("&nbsp;,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter");

        contacts.gridView.init();
        //contacts.gridView.attachEvent("onXLE", contacts.OnContactsLoaded)
        //contacts.gridView.load('/v7/axml/contacts.fts?type=grid&mailbox=' + currentMailbox + "&abid=" + currentFolder+extraData, "json");
        contacts.gridView.attachEvent("onRowDblClicked", contacts.SelectContact)
        contacts.gridView.enableMultiselect(true)
    }
    else {
        contacts.toolbar.setItemState("card", true)
        contacts.toolbar.setItemState("list", false)
        contacts.dataView = rightTop.attachDataView({
            container: "data_container",
            type: {
                template: "http->/v7/webmail/contact_card_templete.html",
                css: "custom",
                width: 400,
                height: 270,
                margin: 15,
                padding: 0
            },
            drag: false
        });
        //contacts.dataView.attachEvent("onXLE", contacts.OnContactsLoaded)
        //contacts.dataView.load('/v7/axml/contacts.fts?mailbox=' + currentMailbox + "&abid=" + currentFolder+extraData, "json", function() {contacts.dataView.sort("#name#","asc")});
        contacts.dataView.attachEvent('onItemDblClick', contacts.SelectContact)
    }
    contacts.UpdateView();
    contacts.showHideTools();
}

contacts.OnContactsLoaded=function() {
    rightPane.progressOff()
    }

contacts.SelectContact=function(id)
{
    var name=""
    if (contacts.isListView)
        name=contacts.gridView.cells(id,1).getValue()
    else
        name=contacts.dataView.get(id).cn
    top.OpenDialog(850,600,name,'/v7/webmail/mbx_contact_edit.fts?cid='+id+"&abid="+contacts.projectItem.id+"&mailbox="+contacts.project.uid+"&r="+contacts.projectItem.rights,contacts.ReloadContactData)
}

 contacts.onValueChange=function(id)
{
    searchText=contacts.toolbar.getValue(id).toLowerCase()
    if (contacts.isListView)
    {

    }
    else
    {
        contacts.dataView.filter(function(obj)
        {
            if (searchText==obj.cn.toLowerCase().slice(0,searchText.length)) return true;
            if (searchText==obj.givenname.toLowerCase().slice(0,searchText.length)) return true;
            if (searchText==obj.sn.toLowerCase().slice(0,searchText.length)) return true;
            if (searchText==obj.o.toLowerCase().slice(0,searchText.length)) return true;
            if (searchText==obj.mail.toLowerCase().slice(0,searchText.length)) return true;
            if (obj.mail.search(searchText)!=-1) return true;
            return false;
        })
    }
}

 contacts.DeleteEntry=function()
{
    var selIds=""
    if (contacts.isListView)
        selIds=contacts.gridView.getSelectedRowId();
    else
        selIds=contacts.dataView.getSelected();
    contacts.ReloadContactData("&remove=" + selIds);
    contacts.gridView.clearAll()
}

 contacts.AddEntry=function()
{
    if (contacts.projectItem.type==47)
    {
        // display a windows showing all the domain members to add to the group
        top.OpenDialog(700,400,"",'/v7/webmail/groupmembers.fts?mailbox=' + contacts.project.uid + "&abid=" + contacts.projectItem.id,contacts.ReloadContactData);
    }
    else
    {
        top.OpenDialog(700,400,"",'/v7/webmail/addmember.fts?mailbox=' + contacts.project.uid + "&abid=" + contacts.projectItem.id,contacts.ReloadContactData);
    }
}

contacts.onButtonChange = function (id) {
    if (id == "btn_export") {
        window.open("/tools/vcfexport.fts?raw=0&fid=" + contacts.projectItem.id);
    }
    if (id == "btn_rawexport") {
        window.open("/tools/vcfexport.fts?raw=1&fid=" + contacts.projectItem.id);
    }

    if (id == "btn_import") {
        top.OpenDialog(700, 400, tmxlang["_drop_file_here"], '/v7/utility/importcontacts.fts?fid=' + contacts.projectItem.id, contacts.ReloadContactData);
    }

    if (id == "btn_print") {
        contacts.gridView.printView()
        return true;
    }

    if (id == "card") {
        contacts.showCardView();
        return true;
    }
    if (id == "list") {
        contacts.showListView();
        return true;
    }
    if (id == "add") {
        contacts.AddEntry();
        return true;
    }
    if (id == "del") {
        contacts.DeleteEntry()
        return true;
    }
    if (id == "clear")
        text = ""
    else
        text = id.slice(2, 9999);
    contacts.toolbar.setValue("search", text)
    contacts.currentPressedButton = id
    contacts.onValueChange("search")
    return true;
}

 contacts.showCardView=function()
{
    contacts.isListView=false;
    contacts.ChangeView();
    contacts.showHideTools();
}

 contacts.showListView=function()
{
    contacts.isListView=true;
    contacts.ChangeView();
    contacts.showHideTools();
}

contacts.showHideTools = function (id) {
    var rights = contacts.projectItem.rights
    var canmanage = rights.indexOf("m") != -1
    var canedit = rights.indexOf("w") != -1
    var candelete = rights.indexOf("d") != -1
    contacts.showToolbarItem("add", canedit || canmanage)
    contacts.showToolbarItem("del", candelete || canmanage)
    if (contacts.projectItem.type == 47) // group members
        canmanage = false;
    contacts.showToolbarItem("btn_import", canmanage)
    contacts.showToolbarItem("btn_export", canmanage)
    contacts.showToolbarItem("btn_rawexport", canmanage==false)

    contacts.showToolbarItem("s0", contacts.isListView)
    contacts.showToolbarItem("btn_print", contacts.isListView)
    contacts.showToolbarItem("search", !contacts.isListView)
    contacts.showToolbarItem("clear", !contacts.isListView)
}

contacts.showToolbarItem = function(id, show)
{
    if (show)
        contacts.toolbar.showItem(id)
    else
        contacts.toolbar.hideItem(id)
}








