// task functions
var issues =
{
    subTypeTitles: "_nav_tasklist",
    subTypeEditors: "mbx_ical_edit_task.fts",
    subTypeList: "tasklist.fts",
    grid: null,
    toolbar: null,
    selectedCell: 0,
    wantInit: true,
    project: null,
    options:[],
    projItem: {}
}

issues.Hide = function () {
    projectsView.main_layout.cells('b').view("def").setActive();
}

issues.Init=function()
{
    issues.selectedCell = 0

    if (issues.wantInit)
    {
        issues.wantInit=false;
        subTypeTitles=tmxlang["_nav_tasklist"],
        projectsView.main_layout.cells('b').view("issues").setText(issues.subTypeTitles);
        rightPane = projectsView.main_layout.cells('b').view("issues");//.attachLayout('1C').cells("a");
        rightPane.hideHeader()
        issues.grid = rightPane.attachGrid();
        issues.grid.setIconsPath('/imgs/');
        issues.grid.enableDragAndDrop(true);
        issues.grid.attachEvent("onXLE", issues.OnDataLoaded)
        //this.grid.attachEvent("onRowSelect", onRowSelect);
        issues.grid.attachEvent("onRowDblClicked", issues.onRowSelect);
        issues.grid.attachEvent("onAfterSorting", issues.ListSorted);

        issues.toolbar = rightPane.attachToolbar()
        issues.toolbar.addButton("add", null, tmxlang["_btn_add"], '/images/add.gif', '/images/add.gif')
        issues.toolbar.addButton("del", null, tmxlang["_btn_delete"], '/images/buttons/icons/purge.gif', '/images/buttons/icons/purge.gif')
        issues.toolbar.addButton("btn_print", null, tmxlang["_print"], "/imgs/icons/printer.png")
        issues.toolbar.attachEvent("onclick", issues.OnToolbar);

        issues.toolbar.addSeparator('s1', null);
        issues.options = [['group_0', 'obj', tmxlang["_none"]],
                       ['group_2', 'obj', tmxlang["_assignee"]],
                       ['group_5', 'obj', tmxlang["_priority"]],
                       ['group_6', 'obj', tmxlang["_status"]],
                       ['group_7', 'obj', tmxlang["_category"]]]
        issues.toolbar.addButtonSelect("groupi", null, tmxlang["_group"], issues.options)
        issues.toolbar.setItemToolTip("groupi", tmxlang["_add"])

    }
}

issues.Show = function (item, project) {
    issues.projItem = item;
    issues.project=project;
    projectsView.main_layout.cells('b').view("issues").setActive()
    issues.UpdateRights()
    issues.Refresh()
}

issues.SortDateDue = function (a, b, order, ra, rb) {
    a1 = issues.grid.getUserData(ra, 'due');
    b1 = issues.grid.getUserData(rb, 'due');
    if (a1 == b1)
        return 0
    return (a1 > b1 ? 1 : -1) * (order == "asc" ? 1 : -1);
}

issues.UpdateRights = function () {
    var canDelete=issues.project.userdata=="owner" || issues.project.userdata=="manager";
    if (canDelete)
        issues.toolbar.enableItem("del")
    else
        issues.toolbar.disableItem("del")
}

issues.ListSorted = function (sortIndex, sortType, sortDirection) {
    accountView.SetPreference("sort_"+issues.projItem.id, sortIndex + "," + sortType + "," + sortDirection);
}

issues.OnDataLoaded = function () {
    projectsView.main_layout.cells('b').progressOff()
    issues.grid.enableMultiselect(true);
    issues.Group()
    mailsort = accountView.GetPreference("sort_" + issues.projItem.id) || ""
    var st = mailsort.split(",")
    if (st.length == 3) {
        sortIndex = st[0]
        sortType = st[1]
        sortDirection = st[2]
        issues.grid.sortRows(sortIndex, sortType, sortDirection)
    }
    else
        issues.grid.sortRows(1)

    if (issues.selectedCell != 0) {
        issues.grid.setSelectedRow(issues.selectedCell)
        issues.grid.showRow(issues.selectedCell);
    }
}

issues.Refresh = function () {
    projectsView.main_layout.cells('b').progressOn()
    issues.grid.load('/v7/axml/' + issues.subTypeList + '?fid=' + issues.projItem.id, 'xml');
}

issues.Group = function (index) {
    if (index == undefined)
        index = accountView.GetPreference("issues.group") || 0
    else
        accountView.SetPreference("issues.group", index);
    if (index == 0)
        issues.grid.unGroup();
    else
        issues.grid.groupBy(index)
}

issues.onRowSelect = function (id) {
    var title = issues.grid.getUserData(id, "title");
    var rights = "r";
    var assignee=issues.grid.getUserData(id, "assignee");
    var title = issues.grid.getUserData(id, "title");
    if (assignee == issues.project.author || issues.project.userdata == "owner" || issues.project.userdata == "manager" || assignee == "")
        rights="rwdm";
    top.OpenDialog(850, 640, title, "/v7/webmail/" + issues.subTypeEditors + "?fid=" + issues.projItem.id + "&m=" + issues.project.author + "&eid=" + id + "&r=" + rights, issues.Refresh)
    return false;
}

issues.OnToolbar = function (id) {
    if (id == "add") {
        top.OpenDialog(850, 600, tmxlang["_new"], "/v7/webmail/" + issues.subTypeEditors + "?fid=" + issues.projItem.id + "&m=" + issues.project.author + "&eid=0" + "&r=" + issues.projItem.rights, issues.Refresh)
    }
    if (id == "del") {
        // hide the edit box
        var checkIds = issues.grid.getSelectedRowId();
        issues.grid.load('/v7/axml/' + issues.subTypeList + '?fid=' + issues.projItem.id + "&m=" + issues.project.author + "&remove=" + checkIds, 'xml');
    }
    if (id.indexOf("group") != -1) {
        var g = id.split("_")
        issues.Group(g[1])
    }
    if (id == "btn_print")
        issues.grid.printView()

}