// schedule functions
var calendar = {
    logViewChanges: true,
    activetzname: "",
    checkedIds: [],
    loadIndex: 0,
    selectedEventId: 0,
    calendarView: null,
    wantInit: true,
    calendarObject: null,
    selectedDate: null,
    project:null,
    projItem: {}
}

calendar.Hide = function () {
    calendar.logViewChanges = false;
    var ccv=localStorage["calendar_view"]
    if (ccv=="agenda")
        scheduler.setCurrentView(top.scratchData["cal_date"],"week")
    calendar.logViewChanges=true;
    projectsView.main_layout.cells('b').view("def").setActive();
}

calendar.ViewChange = function (mode, date) {
    if (calendar.logViewChanges) {
        localStorage["calendar_view"] = mode
        calendar.selectedDate = date
    }
}

calendar.Init = function () {
    calendar.wantInit = false;

    if (localStorage["calendar_view"] == undefined) {
        localStorage["calendar_view"] == "week_agenda"
        calendar.selectedDate = new Date()
    }
    scheduler.config.multi_day = true;
    scheduler.config.xml_date = "%Y-%m-%d %H:%i";
    scheduler.config.prevent_cache = true;
    scheduler.locale.labels.agenda_tab = tmxlang["_list"]
    scheduler.locale.labels.day_tab = tmxlang["_day"]
    scheduler.locale.labels.week_tab = tmxlang["_week"]
    scheduler.locale.labels.month_tab = tmxlang["_month"]
    scheduler.locale.labels.week_agenda_tab = tmxlang["_agenda"]
    // set the range of the agenda view to be everything up to a year ahead
    scheduler.config.agenda_start = new Date();
    scheduler.config.agenda_start.setHours(0);
    scheduler.config.agenda_start.setMinutes(0);
    scheduler.config.agenda_start.setSeconds(0);
    scheduler.config.agenda_end = new Date()
    scheduler.config.agenda_end.setFullYear(scheduler.config.agenda_end.getFullYear() + 1)
    scheduler.config.full_day = true
    scheduler.config.server_utc = true
    scheduler.attachEvent("onViewChange", calendar.ViewChange);
    scheduler.showLightbox = calendar.showEvent
    scheduler.attachEvent("onEventChanged", calendar.EventChanged)
    scheduler.attachEvent("onEventSave", calendar.EventChanged)
    scheduler.attachEvent("onEventDeleted", calendar.EventDeleted)
    scheduler.attachEvent("onEventCreated", calendar.EventCreated)
    scheduler.attachEvent("onClick", calendar.showEvent)
    scheduler.config.details_on_create = 1
    scheduler.config.first_hour = 9

    // the main window
    var temp = '<div class="dhx_cal_navline">'
    temp += '<div class="dhx_minical_icon" id="add_icon" onclick="scheduler.addEvent()" style="background: url(/images/add.gif);background-repeat:no-repeat;background-position:left top;left:10px;width:20px;height:20px;top:2px;padding-left:20px;padding-top:3px;" title="' + tmxlang["_btn_add"] + '">' + tmxlang["_btn_add"] + '</div>'
    temp += '<div class="dhx_minical_icon" id="export_icon" onclick="calendar.export_calendar()" style="background: url(/imgs/save.png);left:100px;width:16px;height:16px;top:4px" title="' + tmxlang["_btn_export"] + '">&nbsp;</div>'
    temp += '<div class="dhx_minical_icon" id="import_icon" onclick="calendar.import_calendar()" style="background: url(/imgs/import.png);left:130px;width:16px;height:16px;top:4px" title="' + tmxlang["_btn_import"] + '">&nbsp;</div>'
    temp += '<div class="dhx_cal_prev_button" style="left:150px">&nbsp;</div>'
    temp += '<div class="dhx_cal_next_button" style="left:180px">&nbsp;</div>'
    temp += '<div class="dhx_cal_today_button" style="left:210px"></div>'
    temp += '<div class="dhx_minical_icon" style="left:290px" id="dhx_minical_icon" onclick="show_minical()">&nbsp;</div>'
    temp += '<div class="dhx_cal_date" style="left:330px">&nbsp;</div>'
    temp += '<div class="dhx_cal_tab" name="agenda_tab" style="right:350px;"></div>'
    temp += '<div class="dhx_cal_tab" name="week_agenda_tab" style="right:280px;"></div>'
    temp += '<div class="dhx_cal_tab" name="month_tab" style="right:76px;"></div>'
    temp += '<div class="dhx_cal_tab" name="week_tab" style="right:140px;"></div>'
    temp += '<div class="dhx_cal_tab" name="day_tab" style="right:204px;"></div>'
    temp += '</div><div class="dhx_cal_header"></div><div class="dhx_cal_data"></div>'

    // attach it to the main display
    calendar.logViewChanges = false;
    projectsView.main_layout.cells('b').view("calendar").attachScheduler(temp)
    scheduler.setCurrentView(new Date(), "week")
    var tz = jstz.determine(); // Determines the time zone of the browser client
    activetzname = tz.name()
    calendar.logViewChanges = true;

}

calendar.Show = function (item, project) {
    calendar.projItem = item;
    calendar.project=project
    if (calendar.wantInit)
        calendar.Init()

    scheduler.currentRights="w"

    projectsView.main_layout.cells('b').view("calendar").setActive()
    calendar.ReloadData();
}

calendar.CalendarChecked=function(id, state) {
    if (state == 1)
        calendar.checkedIds.push(id)
    else {
        var index = calendar.checkedIds.indexOf(id)
        if (index != -1)
            calendar.checkedIds.splice(index, 1)
    }
    calendar.loadIndex = 0;
    calendar.ReloadData();
}

calendar.ReloadData = function (extra) {
    projectsView.main_layout.cells('b').view("calendar").progressOn();
    scheduler.clearAll();
    // list the folders that are checked
    scheduler.load("/v7/axml/ical.fts?mailbox=" + calendar.project.uid + "&fid=" + calendar.projItem.id, "ical", calendar.DataLoaded);
    //scheduler.load("/UK-holidays.ics", "ical",DataLoaded);
    //scheduler.load("/meetup.ics", "ical", DataLoaded);
    //scheduler.load("/UK32Holidays.ics", "ical", DataLoaded);
}

calendar.DataLoaded = function () {
    projectsView.main_layout.cells('b').view("calendar").progressOff();
    scheduler.setCurrentView(calendar.selectedDate, localStorage["calendar_view"])
}

calendar.EventAdded = function (eventId, event) {
    if (currentRights.indexOf("c") != -1) {
        selectedEventId = eventId
        event.duration = Math.floor((event.end_date.valueOf() - event.start_date.valueOf()) / 1000)
        EventEditorSave(event)
    }
    else
        sheduler.deleteEvent(eventId);
}

calendar.showEvent = function (evId) {
    evId = "" + evId
    calendar.selectedEventId = evId.split("#")[0]
    top.SetEvent("onCalEditorLoaded", calendar.EventEditorLoaded)
    top.SetEvent("onCalEditorSave", calendar.EventEditorSave)
    top.SetEvent("onCalEventDelete", calendar.EventEditorDelete)
    top.SetEvent("onCalEventRights", calendar.EventEditorRights)
    var ev = scheduler.getEvent(calendar.selectedEventId)
    top.OpenDialog(620, 430, ev.text, "/v7/webmail/edit_ical2.fts?fid="+calendar.projItem.id+"&r=" + calendar.projItem.rights)
}

// sequence for a new item being created
// record it as a new event
// show the editor
// if the user hits save:
// get a new id
// update the event id
// send the updated data

calendar.EventCreated = function (event_id, event_object) {
    var ev = scheduler.getEvent(event_id)
    ev.isnew = true
    ev.organizer = calendar.project.account;
}

calendar.ICalUpdated = function (loader) {
    scheduler.changeEventId(calendar.selectedEventId, loader.xmlDoc.responseText);
    if (scheduler.updateView)
        scheduler.updateView()
}

calendar.EventEditorSave = function (newEv) {
    var action = "update";
    var ev = scheduler.getEvent(calendar.selectedEventId)
    if (ev.organizer == undefined || ev.organizer == "undefined")
        ev.organizer = calendar.project.account;
    if (ev.isnew) {
        action = "create"
        delete ev.isnew
    }
    scheduler.initEventEndDates(ev)
    ev["selectedEvent"] = calendar.selectedEventId;
    dhtmlxAjax.post("/api/v7/axml/ical.fts?mailbox=" + calendar.project.uid + "&fid=" + calendar.projItem.id + "&action="+action,
                "ical=" + encodeURIComponent(JSON.stringify(ev)), calendar.ICalUpdated);
    setTimeout("calendar.ReloadData()", 100)
}

calendar.EventChanged=function(event_id, ev) {
    var data = ToICal(event_id, ev)
    scheduler.initEventEndDates(ev)
    data = encodeURIComponent(data)
    data = "ical=" + data;
    dhtmlxAjax.post("/api/v7/axml/ical.fts?mailbox=" + calendar.project.uid + "&fid=" + NormaliseFolderId(calendar.projItem.id) + "&action=update", "ical=" + encodeURIComponent(JSON.stringify(ev)));
    
    setTimeout("calendar.ReloadData()", 100)
}

calendar.EventEditorDelete=function(uid) {
    //EventDeleted(calendar.selectedEventId, ev)
    if (uid!="")
        dhtmlxAjax.post("/api/v7/axml/ical.fts?mailbox=" + calendar.project.uid + "&fid=" + NormaliseFolderId(calendar.projItem.id) + "&action=delete","uid=" + uid);
    scheduler.deleteEvent(calendar.selectedEventId)

    if (scheduler.updateView)
        scheduler.updateView()
}

calendar.EventEditorRights = function () {
    return calendar.projItem.rights;
}

calendar.EventEditorLoaded = function (win) {
    var ev = scheduler.getEvent(calendar.selectedEventId)
    return ev
}

calendar.export_calendar = function () {
    window.open("/v7/axml/ical.fts?mailbox=" + calendar.project.uid + "&fid=" + calendar.projItem.id, "_blank")
}


calendar.import_calendar = function () {
    top.OpenDialog(620, 430,tmxlang["_drop_file_here"], "/v7/utility/importcal.fts?fid=" + calendar.projItem.id + "&r=" + calendar.projItem.rights,calendar.ReloadData)
    
}


