// task functions
var tasks =
{
    subTypeTitles: "_nav_tasklist",
    subTypeEditors: "mbx_ical_edit_task.fts",
    subTypeList: "tasklist.fts",
    grid: null,
    toolbar: null,
    selectedCell: 0,
    wantInit: true,
    project: null,
    options:[],
    projItem: {}
}

tasks.Hide = function () {
    projectsView.main_layout.cells('b').view("def").setActive();
}

tasks.Init=function()
{
    tasks.selectedCell = 0

    if (tasks.wantInit)
    {
        tasks.wantInit=false;
        subTypeTitles=tmxlang["_nav_tasklist"],
        projectsView.main_layout.cells('b').view("tasks").setText(tasks.subTypeTitles);
        rightPane = projectsView.main_layout.cells('b').view("tasks")//.attachLayout('1C').cells("a");
        rightPane.setText("tasks")

        tasks.grid = rightPane.attachGrid();
        tasks.grid.setIconsPath('/imgs/');
        tasks.grid.enableDragAndDrop(true);
        tasks.grid.attachEvent("onXLE", tasks.OnDataLoaded)
        //this.grid.attachEvent("onRowSelect", onRowSelect);
        tasks.grid.attachEvent("onRowDblClicked", tasks.onRowSelect);

        tasks.toolbar = rightPane.attachToolbar()
        tasks.toolbar.addButton("add", null, tmxlang["_btn_add"], '/images/add.gif', '/images/add.gif')
        tasks.toolbar.addButton("del", null, tmxlang["_btn_delete"], '/images/buttons/icons/purge.gif', '/images/buttons/icons/purge.gif')
        tasks.toolbar.addButton("btn_print", null, tmxlang["_print"], "/imgs/icons/printer.png")
        tasks.toolbar.attachEvent("onclick", tasks.OnToolbar);

        tasks.toolbar.addSeparator('s1', null);
        tasks.options= [['groupt_0', 'obj', tmxlang["_none"]],
                       ['groupt_2', 'obj', tmxlang["_assignee"]],
                       ['groupt_5', 'obj', tmxlang["_category"]]]
        tasks.toolbar.addButtonSelect("groupt", null, tmxlang["_group"], tasks.options)
        tasks.toolbar.setItemToolTip("groupt", tmxlang["_add"])

    }
}

tasks.Show = function (item, project) {
    tasks.projItem = item;
    tasks.project=project;
    projectsView.main_layout.cells('b').view("tasks").setActive()
    tasks.UpdateRights()
    tasks.Refresh()
}

tasks.SortDateDue = function (a, b, order, ra, rb) {
    a1 = tasks.grid.getUserData(ra, 'due');
    b1 = tasks.grid.getUserData(rb, 'due');
    if (a1 == b1)
        return 0
    return (a1 > b1 ? 1 : -1) * (order == "asc" ? 1 : -1);
}

tasks.UpdateRights = function () {
    var canDelete=tasks.project.userdata=="owner" || tasks.project.userdata=="manager";
    if (canDelete)
        tasks.toolbar.enableItem("del")
    else
        tasks.toolbar.disableItem("del")
/*

    var canEdit = ((tasks.projItem.rights.indexOf("m") != -1) || (tasks.projItem.rights.indexOf("d") != -1) || (tasks.projItem.rights.indexOf("c") != -1))
    if (canEdit) {
        tasks.toolbar.enableItem("add")
    }
    else {
        tasks.toolbar.disableItem("add")
    }
*/  
}

tasks.OnDataLoaded = function () {
    projectsView.main_layout.cells('b').progressOff()
    tasks.grid.enableMultiselect(true);
    tasks.grid.sortRows(1)
    tasks.Group()
    if (tasks.selectedCell != 0) {
        tasks.grid.setSelectedRow(tasks.selectedCell)
        tasks.grid.showRow(tasks.selectedCell);
    }
}

tasks.Refresh = function () {
    projectsView.main_layout.cells('b').progressOn()
    tasks.grid.load('/v7/axml/' + tasks.subTypeList + '?fid=' + tasks.projItem.id, 'xml');
}

tasks.Group = function (index) {
    if (index == undefined)
        index = accountView.GetPreference("tasks.group") || 0
    else
        accountView.SetPreference("tasks.group", index);
    if (index == 0)
        tasks.grid.unGroup();
    else
        tasks.grid.groupBy(index)
}

tasks.onRowSelect = function (id) {
    var title = tasks.grid.getUserData(id, "title");
    var rights = "r";
    var assignee=tasks.grid.getUserData(id, "assignee");
    var title = tasks.grid.getUserData(id, "title");
    if (assignee==tasks.project.author || tasks.project.userdata=="owner" || tasks.project.userdata=="manager" || assignee=="")
        rights="rwdm";
    top.OpenDialog(850, 640, title, "/v7/webmail/" + tasks.subTypeEditors + "?fid=" + tasks.projItem.id + "&m=" + tasks.project.author + "&eid=" + id + "&r=" + rights, tasks.Refresh)
    return false;
}

tasks.OnToolbar = function (id) {
    if (id == "add") {
        top.OpenDialog(850, 600, tmxlang["_new"], "/v7/webmail/" + tasks.subTypeEditors + "?fid=" + tasks.projItem.id + "&m=" + tasks.project.author + "&eid=0" + "&r=" + tasks.projItem.rights, tasks.Refresh)
    }
    if (id == "del") {
        // hide the edit box
        var checkIds = tasks.grid.getSelectedRowId();
        tasks.grid.load('/v7/axml/' + tasks.subTypeList + '?fid=' + tasks.projItem.id + "&m=" + tasks.project.author + "&remove=" + checkIds, 'xml');
    }
    if (id.indexOf("group") != -1) {
        var g = id.split("_")
        tasks.Group(g[1])
    }
    if (id=="btn_print")
        tasks.grid.printView()
        
}
